ADAPTER_DATA Struct ALIGNMODE
	dwAddress		DQ	?
	dwIndex			DQ	?
	dwMask			DQ	?
	dwType			DQ	?
	dwLastBytesIn	DQ	?
	dwLastBytesOut	DQ	?
	dwLastSpeedIn	DQ	?
	dwLastSpeedOut	DQ	?
ADAPTER_DATA ENDS

.Const

IfOperStatusUp				Equ			1
IfOperStatusDown			Equ			2
IfOperStatusTesting			Equ			3
IfOperStatusUnknown			Equ			4
IfOperStatusDormant			Equ			5
IfOperStatusNotPresent		Equ			6
IfOperStatusLowerLayerDown	Equ			7

MIB_IF_TYPE_OTHER			Equ			1
MIB_IF_TYPE_ETHERNET		Equ			6
MIB_IF_TYPE_TOKENRING		Equ			9
MIB_IF_TYPE_FDDI			Equ			15
MIB_IF_TYPE_PPP				Equ			23
MIB_IF_TYPE_LOOPBACK		Equ			24
MIB_IF_TYPE_SLIP			Equ			28

STATUS_DISCONN				Equ			(-1)
STATUS_NONE					Equ			0
STATUS_RECEIVE				Equ			1
STATUS_SEND					Equ			2

MC_RESIZE					Equ			9999

WM_TRAYMESSAGE				Equ			(WM_USER + 2048)

.Data?

dwIfTableIndex				QWord		64 Dup(?)

rcLarge						RECT		<?>
rcSmall						RECT		<?>

.Data

szLeft						Byte		'Left', 0
szTop						Byte		'Top', 0

dwCurrentIndex				QWord		(-1)
dwNumConns					QWord		0
dwNetState					QWord		STATUS_NONE
dwPtrSize					QWord		64
dwCounter1					QWord		0
dwCounter2					QWord		0
dwCounter3					QWord		0
dwCountDown					QWord		(-1)
WM_TASKBARCREATED			QWord		(-1)
bCountDownActive			QWord		FALSE
bFirst						QWord		TRUE
bDoThread					QWord		TRUE
bLocalTcpDescending			QWord		TRUE
bLocalUdpDescending			QWord		TRUE
bModalWindowOn				QWord		FALSE
bRealIPAddress				QWord		FALSE
bRefreshingTcp				QWord		FALSE
bRefreshingUdp				QWord		FALSE
bRemoteTcpDescending		QWord		FALSE
bRemoteUdpDescending		QWord		FALSE
bScrolling					QWord		FALSE
bShowIcon					QWord		FALSE
bSmallSize					QWord		FALSE
bStateTcpDescending			QWord		TRUE
bStateUdpDescending			QWord		TRUE
bThreadActive				QWord		FALSE
bTcpPortsTab				QWord		FALSE
bUdpPortsTab				QWord		FALSE
lCurrentTcpSort				QWord		1
lCurrentUdpSort				QWord		1
lLeft						QWord		0
lLargeTop					QWord		0
lTimer						QWord		0
lSmallTop					QWord		0
hWndCombo					HWND		NULL
hWndLvTcp					HWND		NULL
hWndLvUdp					HWND		NULL
lpPtr						LPVOID		NULL
hIpHlpApi					HINSTANCE	NULL
hMainMenu					HMENU		NULL
hMainSubMenu				HMENU		NULL
hTcpMenu					HMENU		NULL
hTcpSubMenu					HMENU		NULL
hUdpMenu					HMENU		NULL
hUdpSubMenu					HMENU		NULL
hIconDisconn				HICON		NULL
hCursorHand					HCURSOR		NULL
hMutex						HANDLE		NULL

dwRS_ONE_KB					QWord		1024
dwRS_ONE_KB_DIV_10			QWord		102
dwRS_ONE_MB					QWord		1048576 ;(1024 * 1024)
dwRS_ONE_MB_DIV_10			QWord		104857

SpeedScale    				QWord		0

MibIfRow2					MIB_IF_ROW2	<{0}>

include ECProtos.inc ; .Code

NetMonProcedure Proc FastCall Frame hWnd:HWND, uMsg:QWord, wParam:WPARAM, lParam:LPARAM
	Local rc:RECT, pt:POINTL

	Mov Rax, WM_TASKBARCREATED
	.If Rax == uMsg
		Invoke Shell_NotifyIcon, NIM_ADD, Addr IconData
	.ElseIf uMsg == WM_CREATE
		Invoke GlobalAlloc, GPTR, MAX_PATH
		Mov Rsi, Rax
		Invoke CreateWindowEx, 0, TextStr("LISTBOX"), NULL, WS_CHILD, -10, -10, 0, 0, App.Main, 0, App.Instance, NULL
		Mov hWndLBStr, Rax
		Invoke GetAppStrings, IDR_LANGUAGE_FILE
		Invoke SetText, hWnd, App.Header

        Invoke GetPlatform, NULL
        .If QWord Ptr Rax < ecWinVista
			Invoke LoadAppString, IDS_NO_WINXP, Rsi, MAX_PATH
			Invoke MessageBox, hWnd, Rsi, App.Header, MB_OK
			Invoke SendMessage, hWndLBStr, LB_RESETCONTENT, 0, 0
			Invoke DestroyWindow, hWndLBStr
			Invoke GlobalFree, Rsi
			Mov Rax, (-1)
			Jmp L4
        .EndIf

		Invoke LoadAndSetText, hWnd, Rsi, IDS_ADAPTER, IDC_NETMON_GROUP1
		Invoke LoadAndSetText, hWnd, Rsi, IDS_SECOND_TRASNFER_SPEED, IDC_NETMON_GROUP3
		Invoke LoadAndSetText, hWnd, Rsi, IDS_SPEED, IDC_NETMON_STATIC1
		Invoke LoadAndSetText, hWnd, Rsi, IDS_SUBMASK, IDC_NETMON_STATIC2
		Invoke LoadAndSetText, hWnd, Rsi, IDS_RECEIVED, IDC_NETMON_STATIC3
		Invoke LoadAndSetText, hWnd, Rsi, IDS_SENT, IDC_NETMON_STATIC4
		Invoke LoadAndSetText, hWnd, Rsi, IDS_IP_ADDRESS, IDC_NETMON_STCLBLIP
		Invoke LoadAndSetText, hWnd, Rsi, IDS_REAL_ADDRESS, IDC_NETMON_STCLBLREALIP
		Invoke LoadAndSetText, hWnd, Rsi, IDS_CONNECTING, IDC_NETMON_STCREALIP
		Invoke LoadAndSetText, hWnd, Rsi, IDS_KBYTES, IDC_NETMON_STCSPEEDOUT
		Invoke LoadAndSetText, hWnd, Rsi, IDS_KBYTES, IDC_NETMON_STCSPEEDIN

		Invoke GlobalFree, Rsi
		Xor Rdi, Rdi
		Invoke CreateMutex, NULL, TRUE, TextStr("RSNetMon")
		Mov hMutex, Rax
		Invoke GetLastError
		Cmp Rax, ERROR_ALREADY_EXISTS
		Jne @F
		Mov Rdi, (-1)
@@:		.If App.Previous != NULL
			Invoke IsWindowVisible, App.Previous
			Or Rax, Rax
			Jnz @F
			Invoke SendMessage, App.Previous, WM_COMMAND, IDM_MENU_MONITOR, NULL
@@:			Invoke SetActiveWindow, App.Previous
			Invoke SetForegroundWindow, App.Previous
@@:			Invoke SendMessage, hWndLBStr, LB_RESETCONTENT, 0, 0
			Invoke DestroyWindow, hWndLBStr
			Return(-1)
		.EndIf
		Cmp Rdi, (-1)
		Je @B
		Invoke GetPlatform, NULL
		Mov lPlatForm, Rax
@@:		Invoke LoadLibrary, TextStr("IPHLPAPI.dll")
		Mov hIpHlpApi, Rax
		Or Rax, Rax
		Jz @F
		Invoke GetProcAddress, hIpHlpApi, TextStrA("GetExtendedTcpTable")
		Mov lpGetExtendedTcpTable, Rax
		Invoke GetProcAddress, hIpHlpApi, TextStrA("GetExtendedUdpTable")
		Mov lpGetExtendedUdpTable, Rax
@@:		Lea Rbx, dwIfTableIndex
		Xor Rax, Rax
		Mov Rcx, 64
@@:		Mov [Rbx], Rax
		Add Rbx, 8
		Loop @B

		Invoke GetSystemMenu, hWnd, FALSE
		Mov Rdi, Rax
		Invoke DeleteMenu, Rdi, SC_RESTORE, MF_BYCOMMAND
		Invoke DeleteMenu, Rdi, SC_SIZE, MF_BYCOMMAND
		Invoke DeleteMenu, Rdi, SC_MAXIMIZE, MF_BYCOMMAND
		Invoke DeleteMenu, Rdi, SC_MINIMIZE, MF_BYCOMMAND
		Lea Rsi, szBuffer
		Invoke LoadAppString, IDS_RESIZE, Rsi, 64
		Add Rsi, 128
		Mov [Rsi].MENUITEMINFO.cbSize, SizeOf MENUITEMINFO
		Mov [Rsi].MENUITEMINFO.fType, MFT_STRING
		Mov [Rsi].MENUITEMINFO.fMask, (MIIM_TYPE OR MIIM_ID OR MIIM_STATE)
		Mov [Rsi].MENUITEMINFO.wID, MC_RESIZE
		Mov [Rsi].MENUITEMINFO.fState, MFS_ENABLED
		Lea Rax, szBuffer
		Mov [Rsi].MENUITEMINFO.dwTypeData, Rax
		Invoke InsertMenuItem, Rdi, 1, TRUE, Rsi

		Mov Rax, hWnd
		Mov IconData.hWnd, Rax
		Mov IconData.cbSize, SizeOf NOTIFYICONDATA
		Mov IconData.uFlags, (NIF_ICON Or NIF_MESSAGE Or NIF_TIP)
		Mov IconData.uCallbackMessage, WM_TRAYMESSAGE
		Invoke lstrcpy, Addr IconData.szTip, App.Header
		Invoke GlobalAlloc, GPTR, dwPtrSize
		Mov lpPtr, Rax
		Invoke GetWindowItem, hWnd, IDC_NETMON_COMBO1
		Mov hWndCombo, Rax
		Invoke GetWindowItem, hWnd, IDC_NETMON_IMAGE1
		Mov hWndImage, Rax
		Invoke GetWindowItem, hWnd, IDC_NETMON_IMGDOWN
		Mov hWndImgDown, Rax
		Invoke GetWindowItem, hWnd, IDC_NETMON_IMGUP
		Mov hWndImgUp, Rax
		Invoke GetWindowLong, Rax, GWL_STYLE
		And Rax, 0FFFFFFF0H
		Or Rax, SS_ICON
		Mov Rdi, Rax
		Invoke SetWindowLong, hWndImage, GWL_STYLE, Rax
		Invoke SetWindowLong, hWndImgDown, GWL_STYLE, Rdi
		Invoke SetWindowLong, hWndImgUp, GWL_STYLE, Rdi
		Invoke GetMeterRegistrySettings
		Invoke GetWindowItem, hWnd, IDC_NETMON_GROUP3
		Mov Rdi, Rax
		Invoke CreateMeter, Rdi, 8, 20, RSMETER_INSET
		Mov lMeterDownIndex, Rax
		Invoke SetMeterMaxValue, Rax, lMeterDownMaxValue
		Invoke SetMeterWidth, lMeterDownIndex, 4
		Invoke SetMeterHeight, lMeterDownIndex, 13
		Invoke CreateMeter, Rdi, 8, 37, RSMETER_INSET
		Mov lMeterUpIndex, Rax
		Invoke SetMeterMaxValue, Rax, lMeterUpMaxValue
		Invoke SetMeterWidth, lMeterUpIndex, 4
		Invoke SetMeterHeight, lMeterUpIndex, 13

		Invoke GetWindowItem, hWnd, IDC_NETMON_LISTVIEW1
		Mov hWndLvTcp, Rax
		Invoke GetWindowItem, hWnd, IDC_NETMON_LISTVIEW2
		Mov hWndLvUdp, Rax

		Invoke GetClientRect, hWndLvTcp, Addr rc
		Invoke GetSystemMetrics, SM_CXVSCROLL
		Sub rc.right, Eax
		Xor Rdx, Rdx
		Mov Rax, 3
		Xchg Eax, rc.right
		Push Rax
		Mov Ecx, rc.right
		Div Rcx
		Sub Rax, 10
		Mov rc.right, Eax

		Mov Rbx, 32
		Mov Ecx, rc.right
		Shl Rcx, 1
		Add Ecx, rc.right
		Add Rcx, Rbx
		Pop Rax
		Cmp Rcx, Rax
		Jle @F
		Sub Rcx, Rax
		Sub Rbx, Rcx
@@:		Mov Word Ptr szBuffer [0], 0
		Invoke AddListViewColumn, hWndLvTcp, Addr szBuffer, (-1), 0, LVCFMT_LEFT

		Mov Word Ptr szBuffer[0], 0
		Invoke AddListViewColumn, hWndLvUdp, Addr szBuffer, (-1), 0, LVCFMT_LEFT
		
		Invoke LoadAppString, IDS_LOCAL, Addr szBuffer, 64
		ECInvoke AddListViewColumn, hWndLvTcp, Addr szBuffer, rc.right, 1, LVCFMT_CENTER

		Invoke LoadAppString, IDS_PORT, Addr szBuffer, 64
		Mov Eax, rc.right
		Sub Eax, 20
		Invoke AddListViewColumn, hWndLvUdp, Addr szBuffer, Rax, 1, LVCFMT_CENTER

		Invoke LoadAppString, IDS_REMOTE, Addr szBuffer, 64
		ECInvoke AddListViewColumn, hWndLvTcp, Addr szBuffer, rc.right, 2, LVCFMT_CENTER

		Invoke LoadAppString, IDS_LOCAL_ADDRESS, Addr szBuffer, 64
		Lea Rcx, szBuffer
		Add Rax, Rcx
		Dec Rax
		Mov Byte Ptr [Rax], 0
		Mov Eax, rc.right
		Add Eax, 20
		Invoke AddListViewColumn, hWndLvUdp, Addr szBuffer, Rax, 2, LVCFMT_CENTER

		Add rc.right, Ebx

		Invoke LoadAppString, IDS_STATE, Addr szBuffer, 64
		ECInvoke AddListViewColumn, hWndLvTcp, Addr szBuffer, rc.right, 3, LVCFMT_CENTER

		Invoke LoadAppString, IDS_PROCESS, Addr szBuffer, 64
		Lea Rcx, szBuffer
		Add Rax, Rcx
		Dec Rax
		Mov Byte Ptr [Rax], 0
		ECInvoke AddListViewColumn, hWndLvUdp, Addr szBuffer, rc.right, 3, LVCFMT_CENTER

		Invoke GetRegistryValueA, HKEY_CURRENT_USER, TextStrA("Control Panel\International"), TextStrA("sDecimal"), Addr szBuffer
		.If Rax
			Mov Al, [szBuffer]
			Mov [sDecimal], Al
		.EndIf
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, TextStrA("Control Panel\International"), TextStrA("sThousand"), Addr szBuffer
		.If Rax
			Mov Al, [szBuffer]
			Mov [sThousand], Al
		.EndIf

		Invoke LoadMenu, App.Instance, IDR_MAIN_MENU
		Mov hMainMenu, Rax
		Invoke GetSubMenu, Rax, 0
		Mov hMainSubMenu, Rax
		Invoke LoadMenu, App.Instance, IDR_TCP_MENU
		Mov hTcpMenu, Rax
		Invoke GetSubMenu, Rax, 0
		Mov hTcpSubMenu, Rax
		Invoke LoadMenu, App.Instance, IDR_UDP_MENU
		Mov hUdpMenu, Rax
		Invoke GetSubMenu, Rax, 0
		Mov hUdpSubMenu, Rax

		;Set tabs text
		Invoke GetWindowItem, hWnd, IDC_NETMON_TABSTRIP1
		Mov Rdi, Rax
		Invoke SetTabItemText, Rdi, 0, IDS_ACTIVITY
		Invoke SetTabItemText, Rdi, 1, IDS_TCP_PORTS
		Invoke SetTabItemText, Rdi, 2, IDS_UDP_PORTS

		;Main menu
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_MONITOR, IDS_SHOW_MONITOR, FALSE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_ONTOP, IDS_ALWAYS_ON_TOP, FALSE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_SETTINGS, IDS_SETTINGS, FALSE
		Invoke SetMenuText, hMainSubMenu, 6, IDS_PRIORITY, TRUE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_HIGH, IDS_HIGH, FALSE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_NORMAL, IDS_NORMAL, FALSE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_LOW, IDS_LOW, FALSE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_AFFINITY, IDS_AFFINITY, FALSE
		Invoke SetMenuText, hMainSubMenu, 9, IDS_COUNTDOWN, TRUE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_ACTIVATE, IDS_ACTIVATE, FALSE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_COUNT_SETTINGS, IDS_SETTINGS, FALSE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_ABOUT, IDS_ABOUT, FALSE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_NETWORK, IDS_NETWORK_CONNECTIONS, FALSE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_EXIT, IDS_EXIT, FALSE

		;TCP menu
		Invoke SetMenuText, hTcpMenu, IDM_MENU_CLOSE_PORT, IDS_CLOSE_PORT, FALSE
		Invoke SetMenuText, hTcpMenu, IDM_MENU_TERMINATE_PROCESS, IDS_TERMINATE_PROCESS, FALSE
		Invoke SetMenuText, hTcpMenu, IDM_MENU_DETAILS, IDS_DETAILS, FALSE
		Invoke SetMenuText, hTcpMenu, IDM_MENU_REFRESH, IDS_REFRESH, FALSE

		;UDP menu
		Invoke SetMenuText, hUdpMenu, IDM_MENU_TERMINATE_PROCESS_UDP, IDS_TERMINATE_PROCESS, FALSE
		Invoke SetMenuText, hUdpMenu, IDM_MENU_REFRESH_UDP, IDS_REFRESH, FALSE

		Cmp lpGetExtendedTcpTable, 0
		Jne @F
		Invoke DeleteMenu, hTcpSubMenu, IDM_MENU_TERMINATE_PROCESS, MF_BYCOMMAND
@@:		Cmp lpGetExtendedUdpTable, 0
		Jne @F
		Invoke DeleteMenu, hUdpSubMenu, 1, MF_BYPOSITION
		Invoke DeleteMenu, hUdpSubMenu, IDM_MENU_TERMINATE_PROCESS_UDP, MF_BYCOMMAND
@@:		Invoke LoadImage, App.Instance, IDI_ICON_BOTH, IMAGE_ICON, 32, 32, LR_LOADMAP3DCOLORS
		Mov hIconBoth, Rax
		Invoke LoadImage, App.Instance, IDI_ICON_NO_NET, IMAGE_ICON, 32, 32, LR_LOADMAP3DCOLORS
		Mov hIconDisconn, Rax
		Invoke LoadImage, App.Instance, IDI_ICON_DOWN_OFF, IMAGE_ICON, 16, 16, LR_LOADMAP3DCOLORS
		Mov hIconDownOff, Rax
		Invoke SendMessage, hWndImgDown, STM_SETICON, Rax, 0
		Invoke LoadImage, App.Instance, IDI_ICON_DOWN_ON, IMAGE_ICON, 16, 16, LR_LOADMAP3DCOLORS
		Mov hIconDownOn, Rax
		Invoke LoadImage, App.Instance, IDI_ICON_NONE, IMAGE_ICON, 32, 32, LR_LOADMAP3DCOLORS
		Mov hIconNone, Rax
		Mov IconData.hIcon, Rax
		Invoke SendMessage, hWndImage, STM_SETICON, Rax, 0
		Invoke LoadImage, App.Instance, IDI_ICON_RECEIVE, IMAGE_ICON, 32, 32, LR_LOADMAP3DCOLORS
		Mov hIconReceive, Rax
		Invoke LoadImage, App.Instance, IDI_ICON_SEND, IMAGE_ICON, 32, 32, LR_LOADMAP3DCOLORS
		Mov hIconSend, Rax
		Invoke LoadImage, App.Instance, IDI_ICON_UP_OFF, IMAGE_ICON, 16, 16, LR_LOADMAP3DCOLORS
		Mov hIconUpOff, Rax
		Invoke SendMessage, hWndImgUp, STM_SETICON, Rax, 0
		Invoke LoadImage, App.Instance, IDI_ICON_UP_ON, IMAGE_ICON, 16, 16, LR_LOADMAP3DCOLORS
		Mov hIconUpOn, Rax
		Invoke LoadImage, App.Instance, IDC_CURSOR_HAND, IMAGE_CURSOR, 32, 32, LR_LOADMAP3DCOLORS
		Mov hCursorHand, Rax
		Invoke SetMeterDownNewColor, 00FFFF00H
		Invoke SetMeterUpNewColor, 0000FFFFH

		Invoke GetWindowRect, hWnd, Addr rc
		Mov Eax, rc.right
		Sub Eax, rc.left
		Mov rc.right, Eax
		Mov Eax, rc.bottom
		Sub Eax, rc.top
		Mov rc.bottom, Eax
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szLeft, Addr szBuffer
		.If Rax
			Invoke ValueA, Addr szBuffer
			Mov rc.left, Eax
		.EndIf
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szTop, Addr szBuffer
		.If Rax
			Invoke ValueA, Addr szBuffer
			Mov rc.top, Eax
		.EndIf
		Invoke CopyRect, Addr rcLarge, Addr rc
		Invoke CopyRect, Addr rcSmall, Addr rc
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szSmallLeft, Addr szBuffer
		.If Rax
			Invoke ValueA, Addr szBuffer
			Mov rcSmall.left, Eax
		.EndIf
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szSmallTop, Addr szBuffer
		.If Rax
			Invoke ValueA, Addr szBuffer
			Mov rcSmall.top, Eax
		.EndIf
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szAutoRefreshPorts, Addr szBuffer
		.If Rax
			Invoke ValueA, Addr szBuffer
			.If (SQWord Ptr Rax < 0 || SQWord Ptr Rax > 9)
				Xor Rax, Rax
			.EndIf
			Mov lAutoRefreshPorts, Rax
		.EndIf
		Invoke GetWindowLong, hWnd, GWL_EXSTYLE
		And Rax, (NOT WS_EX_APPWINDOW)
		Invoke SetWindowLong, hWnd, GWL_EXSTYLE, Rax
		Invoke SetWindowPos, hWnd, Rdi, 0, 0, 0, 0, (SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED OR SWP_HIDEWINDOW)
		Invoke GetWindowItem, hWnd, IDC_NETMON_GROUP3
		Mov Rdx, Rax
		Invoke GetWindowRect, Rdx, Addr rc
		Invoke ScreenToClient, hWnd, Addr rc
		Mov Eax, rc.left
		Mov lLeft, Rax
		Invoke GetWindowItem, hWnd, IDC_NETMON_TABSTRIP1
		Mov Rdx, Rax
		Invoke GetWindowRect, Rdx, Addr rc
		Invoke ScreenToClient, hWnd, Addr rc
		Mov Eax, rc.top
		Add Eax, 2
		Mov lSmallTop, Rax
		Invoke GetWindowItem, hWnd, IDC_NETMON_GROUP3
		Mov Rdx, Rax
		Invoke GetWindowRect, Rdx, Addr rc
		Invoke ScreenToClient, hWnd, Addr rc
		Mov Edi, rc.top
		Mov lLargeTop, Rdi
		Sub Rdi, lSmallTop
		Sub rcSmall.bottom, Edi
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szSmallSize, Addr szBuffer
		.If Rax
			Invoke ValueA, Addr szBuffer
			Mov bSmallSize, Rax
		.EndIf
		Invoke SetMonitorSize, hWnd
		Invoke RefreshTcpOpenPorts, hWnd
		Invoke RefreshUdpOpenPorts, hWnd

		Invoke GetWindowItem, hWnd, IDC_NETMON_GRPLISTVIEW
		Invoke ShowWindow, Eax, SW_HIDE
		Invoke InitInterfaces
		Cmp Rax, NO_ERROR
		Je @F
L2:		Invoke SendMessage, hWnd, WM_DESTROY, 0, 0
		Mov Rax, (-1)
		Jmp L4
@@:		Invoke GetWindowItem, hWnd, IDC_NETMON_THREAD
		Invoke ResumeThread, Rax
		Invoke GetCurrentProcess
		Mov Rdi, Rax
		Invoke GetProcessAffinityMask, Rdi, Addr rc.left, Addr rc.right
		Invoke GetSubMenu, hMainMenu, 0
		.If rc.left == 1
			Invoke DeleteMenu, Rax, 7, MF_BYPOSITION
		.Else
			ECInvoke String, rc.left, Addr szBuffer, ecDecimal
			Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szAffinity, Addr szBuffer
			Invoke ValueA, Addr szBuffer
			.If Rax
				Invoke SetProcessAffinityMask, Rdi, Rax
			.EndIf
		.EndIf
		Invoke GetWindowItem, hWnd, IDC_NETMON_THREAD
		Or Rax, Rax
		Jz L2
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szVisible, Addr szBuffer
		.If Rax
			Invoke ValueA, Addr szBuffer
			.If Rax
				Invoke SendMessage, hWnd, WM_COMMAND, IDM_MENU_MONITOR, NULL
			.EndIf
		.EndIf
		Invoke StringA, MFS_CHECKED, Addr szBuffer, ecDecimal
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szOnTop, Addr szBuffer
		Invoke ValueA, Addr szBuffer
		Test Rax, MFS_CHECKED
		.If !Zero?
			Invoke SendMessage, hWnd, WM_COMMAND, IDM_MENU_ONTOP, 0
		.EndIf

		Invoke StringA, BELOW_NORMAL_PRIORITY_CLASS, Addr szBuffer, ecDecimal
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szPriority, Addr szBuffer
		Invoke Value, Addr szBuffer
		Mov Rcx, IDM_MENU_NORMAL
		Cmp Rax, NORMAL_PRIORITY_CLASS
		Je @F
		Mov R8, IDM_MENU_HIGH
		Cmp Rax, ABOVE_NORMAL_PRIORITY_CLASS
		Je @F
		Mov R8, IDM_MENU_LOW
@@:		Invoke SendMessage, hWnd, WM_COMMAND, R8, 0

		Lea Rsi, szBuffer
		Mov Word Ptr [Rsi], '1'
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr sz10Percent, Rsi
		Invoke ValueA, Rsi
		Mov b10Percent, Rax

		Invoke lstrcpyA, Rsi, TextStrA("60")
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szCountSeconds, Rsi
		Invoke ValueA, Rsi
		Mov lCountSeconds, Rax

		Invoke GetWindowItem, hWnd, IDC_NETMON_TABSTRIP1
		Invoke SetFocus, Rax
		Mov Rax, TRUE
		Jmp L4
	.ElseIf uMsg == WM_COMMAND
		Mov Rdi, wParam
		And Rdi, 00000000FFFFFFFFH
		Mov Rsi, Rdi
		Shr Edi, 16
		And Esi, 0000FFFFH
		Invoke OnNetMonCommand, hWnd, Rsi, Rdi, lParam
		 Jmp L4
	.ElseIf uMsg == WM_NOTIFY
		Mov Rax, wParam
		.If Eax == IDC_NETMON_TABSTRIP1
			Mov Rdi, lParam
			.If [Rdi].NMHDR._code == TCN_SELCHANGE
				Invoke GetWindowItem, hWnd, IDC_NETMON_TABSTRIP1
				Invoke SendMessage, Rax, TCM_GETCURSEL, 0, 0
				.If Rax == 0		;Is Tab 0 (Activity)?
					Mov bTcpPortsTab, FALSE
					Mov bUdpPortsTab, FALSE
					Mov Rsi, SW_SHOWNORMAL
				.ElseIf Rax == 1	;Is Tab 1 (TCP Ports)?
					Mov bTcpPortsTab, TRUE
					Mov bUdpPortsTab, FALSE
					Mov Rsi, SW_HIDE
				.ElseIf Rax == 2	;Is Tab 2 (UDP Ports)?
					Mov bUdpPortsTab, TRUE
					Mov bTcpPortsTab, FALSE
					Mov Rsi, SW_HIDE
				.EndIf
				Invoke GetWindowItem, hWnd, IDC_NETMON_GROUP1
				Invoke ShowWindow, Rax, Rsi
				Invoke GetWindowItem, hWnd, IDC_NETMON_GROUP2
				Invoke ShowWindow, Rax, Rsi
				Invoke GetWindowItem, hWnd, IDC_NETMON_GROUP3
				Invoke ShowWindow, Rax, Rsi
				.If bTcpPortsTab
					Invoke ShowWindow, hWndLvTcp, SW_SHOWNORMAL
					Invoke ShowWindow, hWndLvUdp, SW_HIDE
					Invoke RefreshTcpOpenPorts, hWnd
					Mov Rsi, SW_SHOWNORMAL
				.ElseIf bUdpPortsTab
					Invoke ShowWindow, hWndLvUdp, SW_SHOWNORMAL
					Invoke ShowWindow, hWndLvTcp, SW_HIDE
					Invoke RefreshUdpOpenPorts, hWnd
					Mov Rsi, SW_SHOWNORMAL
				.Else
					Invoke ShowWindow, hWndLvTcp, SW_HIDE
					Invoke ShowWindow, hWndLvUdp, SW_HIDE
					Mov Rsi, SW_HIDE
				.EndIf
				Invoke GetWindowItem, hWnd, IDC_NETMON_GRPLISTVIEW
				Mov Rdi, Rax
				Invoke ShowWindow, Rax, Rsi
				Invoke Refresh, Rdi
			.EndIf
		.ElseIf Eax == IDC_NETMON_LISTVIEW1
			Mov Rdi, lParam
			.If [Rdi].NMHDR._code == NM_RCLICK
				Invoke GetCursorPos, Addr rc
				Lea Rdi, szBuffer
				Mov [Rdi].LV_HITTESTINFO.flags, LVHT_ONITEM
				Mov Eax, rc.left
				Mov [Rdi].LV_HITTESTINFO.pt.x, Eax
				Mov Eax, rc.top
				Mov [Rdi].LV_HITTESTINFO.pt.y, Eax
				Invoke ScreenToClient, hWndLvTcp, Addr [Rdi].LV_HITTESTINFO.pt
				Invoke SendMessage, hWndLvTcp, LVM_HITTEST, 0, Rdi
				Xor Rdi, Rdi
				Xor Rsi, Rsi
				.If Rax != (-1)
					Invoke GetTcpEntry, (-1), Addr szBuffer
					.If Rax
						Lea Rax, szBuffer
						.If [Rax].MIB_TCPROW_OWNER_PID.dwOwningPid != (-1)
							Inc Rsi
						.EndIf
						Inc Rdi
					.EndIf
				.EndIf
				Invoke EnableMenu, hTcpSubMenu, IDM_MENU_CLOSE_PORT, Rdi
				Invoke EnableMenu, hTcpSubMenu, IDM_MENU_TERMINATE_PROCESS, Rsi
				Invoke EnableMenu, hTcpSubMenu, IDM_MENU_DETAILS, Rdi
				Invoke TrackPopupMenu, hTcpSubMenu, (TPM_LEFTALIGN Or TPM_LEFTBUTTON), rc.left, rc.top, 0, hWnd, NULL
				Return TRUE
			.ElseIf [Rdi].NMHDR._code == NM_DBLCLK
				Invoke SendMessage, hWnd, WM_COMMAND, IDM_MENU_DETAILS, 0
				Return TRUE
			.ElseIf [Rdi].NMHDR._code == LVN_KEYDOWN
				.If [Rdi].NMLVKEYDOWN.wVKey == VK_RETURN
					Invoke SendMessage, hWnd, WM_COMMAND, IDM_MENU_DETAILS, NULL
					Ret
				.EndIf
			.ElseIf [Rdi].NMHDR._code == LVN_HOTTRACK
				Mov Rdi, lParam
				.If [Rdi].NM_LISTVIEW.iItem != (-1) && !bRefreshingTcp
					Invoke GetTcpEntry, [Rdi].NM_LISTVIEW.iItem, Addr szBuffer
					.If Rax
						.If lTimer
							Invoke KillTimer, hWnd, lTimer
							Mov lTimer, 0
						.EndIf
						Lea Rdi, szBuffer
						Mov Ebx, [Rdi].MIB_TCPROW_OWNER_PID.dwOwningPid
						Mov Ecx, [Rdi].MIB_TCPROW_OWNER_PID.dwRemoteAddr
						Push Rcx
						Mov Rsi, Rdi
						ECInvoke RtlZeroMemory, Rdi, SizeOf PROCESSENTRY32
						Add Rsi, 128
						Mov Rax, Rsi
						Mov Byte Ptr [Rax], ' '
						Inc Rax
						ECInvoke LoadAppString, IDS_PROCESS, Rax, 64
						Add Rax, Rsi
						Inc Rax
						Mov Byte Ptr [Rax], ' '
						Inc Rax
						ECInvoke GetProcessInfo, Rbx, Rax, Rdi
						ECInvoke lstrlen, Rsi
						Add Rax, Rsi
						Mov Byte Ptr [Rax], '-'
						Inc Rax
						Pop Rcx
						Invoke IPToStr, Rcx, Rax
						Invoke SetWindowText, hWnd, Rsi
						Invoke SetTimer, hWnd, 20, 1000, NULL
						Mov lTimer, Rax
					.EndIf
				.EndIf
			.ElseIf [Rdi].NMHDR._code == LVN_COLUMNCLICK
				Mov Edx, [Rdi].NM_LISTVIEW.iSubItem
				Mov R8, Rdx
				Mov lCurrentTcpSort, R8
				.If R8 == 1
					Xor bLocalTcpDescending, 1
				.ElseIf R8 == 2
					Xor bRemoteTcpDescending, 1
				.ElseIf R8 == 3
					Xor bStateTcpDescending, 1
				.EndIf
				Invoke SendMessage, [Rdi].NMHDR.hwndFrom, LVM_SORTITEMSEX, R8, Addr CompareTcpFunction
				Invoke SendMessage, hWndLvTcp, LVM_GETNEXTITEM, (-1), LVNI_SELECTED
				Cmp Rax, (-1)
				Jne @F
				Xor Rax, Rax
@@:				Invoke SendMessage, hWndLvTcp, LVM_ENSUREVISIBLE, Rax, FALSE
			.EndIf
		.ElseIf Eax == IDC_NETMON_LISTVIEW2
			Mov Rdi, lParam
			.If [Rdi].NMHDR._code == LVN_COLUMNCLICK
				Mov Edx, [Rdi].NM_LISTVIEW.iSubItem
				Mov R8, Rdx
				Mov lCurrentUdpSort, R8
				.If R8 == 1
					Xor bLocalUdpDescending, 1
				.ElseIf R8 == 2
					Xor bRemoteUdpDescending, 1
				.ElseIf R8 == 3
					Xor bStateUdpDescending, 1
				.EndIf
				Invoke SendMessage, [Rdi].NMHDR.hwndFrom, LVM_SORTITEMSEX, R8, Addr CompareUdpFunction
				Invoke SendMessage, hWndLvUdp, LVM_GETNEXTITEM, (-1), LVNI_SELECTED
				Cmp Rax, (-1)
				Jne @F
				Xor Rax, Rax
@@:				Invoke SendMessage, hWndLvUdp, LVM_ENSUREVISIBLE, Rax, FALSE
			.ElseIf [Rdi].NMHDR._code == NM_RCLICK
				Invoke GetCursorPos, Addr rc
				Lea Rdi, szBuffer
				Mov [Rdi].LV_HITTESTINFO.flags, LVHT_ONITEM
				Mov Eax, rc.left
				Mov [Rdi].LV_HITTESTINFO.pt.x, Eax
				Mov Eax, rc.top
				Mov [Rdi].LV_HITTESTINFO.pt.y, Eax
				Invoke ScreenToClient, hWndLvUdp, Addr [Rdi].LV_HITTESTINFO.pt
				Invoke SendMessage, hWndLvUdp, LVM_HITTEST, 0, Rdi
				Xor Rsi, Rsi
				.If Rax != (-1)
					Invoke GetUdpEntry, Addr szBuffer
					.If Rax
						Lea Rax, szBuffer
						.If [Rax].MIB_UDPROW_OWNER_PID.dwOwningPid != (-1)
							Inc Rsi
						.EndIf
					.EndIf
				.EndIf
				Invoke EnableMenu, hUdpSubMenu, IDM_MENU_TERMINATE_PROCESS_UDP, Rsi
				Invoke TrackPopupMenu, hUdpSubMenu, (TPM_LEFTALIGN Or TPM_LEFTBUTTON), rc.left, rc.top, 0, hWnd, NULL
				Return TRUE
			.EndIf
		.EndIf
	.ElseIf uMsg == WM_SYSCOMMAND
		.If wParam == MC_RESIZE
			Jmp @F
		.EndIf
	.ElseIf uMsg == WM_NCLBUTTONDBLCLK
@@:		Invoke GetWindowItem, hWnd, IDC_NETMON_TABSTRIP1
		Mov Rbx, Rax
		Invoke SendMessage, Rax, TCM_GETCURSEL, 0, 0
		.If Rax
			Invoke SendMessage, Rbx, TCM_SETCURSEL, 0, 0
			Lea Rsi, szBuffer
			Mov [Rsi].NMHDR.hwndFrom, Rbx
			Mov [Rsi].NMHDR.idFrom, IDC_NETMON_TABSTRIP1
			Mov [Rsi].NMHDR._code, TCN_SELCHANGE
			Invoke SendMessage, hWnd, WM_NOTIFY, IDC_NETMON_TABSTRIP1, Rsi
		.EndIf
		Xor bSmallSize, 1
		Invoke SetMonitorSize, hWnd
		Mov Rax, TRUE
		Jmp L4
	.ElseIf uMsg == WM_TRAYMESSAGE
		.If lParam == WM_LBUTTONDOWN
@@:			Invoke IsWindowEnabled, hWnd
			.If Rax
				Invoke SetForegroundWindow, hWnd
			.EndIf
			Mov Rax, TRUE
			Jmp L4
		.ElseIf lParam == WM_LBUTTONDBLCLK
			Invoke IsWindowVisible, hWnd
			Or Rax, Rax
			Jnz @B
			Invoke SendMessage, hWnd, WM_COMMAND, IDM_MENU_MONITOR, NULL
			Jmp L4
		.ElseIf lParam == WM_RBUTTONUP
			Invoke IsWindowEnabled, hWnd
			.If Rax
				Invoke SetForegroundWindow, hWnd
			.EndIf
			Invoke GetCursorPos, Addr pt
		 	.If bModalWindowOn
		 		Invoke MessageBeep, 0
		 	.Else
				ECInvoke TrackPopupMenu, hMainSubMenu, 0, pt.x, pt.y, 0, hWnd, NULL
			.EndIf
			Mov Rax, TRUE
			Jmp L4
		.EndIf
	.ElseIf uMsg == WM_EXITSIZEMOVE
		Invoke SaveMonitorPosition, hWnd
	.ElseIf uMsg == WM_TIMER
		Mov Rax, wParam
		.If Rax == lTimer
			Invoke KillTimer, hWnd, lTimer
			Mov lTimer, 0
			Invoke SetWindowText, hWnd, App.Header
			Return TRUE
		.EndIf
	.ElseIf uMsg == WM_CLOSE
		Invoke CloseMonitorWindow, hWnd, FALSE
		Invoke SendMessage, hWndLBStr, LB_RESETCONTENT, 0, 0
		Invoke DestroyWindow, hWndLBStr
		Mov Rax, TRUE
		Jmp L4
	.ElseIf uMsg == WM_DESTROY
		.If lTimer
			Invoke KillTimer, hWnd, lTimer
			Mov lTimer, 0
		.EndIf
		Invoke GetTickCount
		Mov Rdi, Rax
		Add Rdi, 1000
		Mov bDoThread, FALSE
		.While bThreadActive
			Invoke GetTickCount
			Cmp Rax, Rdi
			Jge @F
			Invoke Sleep, 1
		.EndW
@@:		Invoke CloseHandle, hMutex
		Invoke Shell_NotifyIcon, NIM_DELETE, Addr IconData
		Invoke DestroyMeter, lMeterDownIndex
		Invoke DestroyMeter, lMeterUpIndex
		Invoke DestroyIcon, hIconBoth
		Invoke DestroyIcon, hIconDisconn
		Invoke DestroyIcon, hIconDownOff
		Invoke DestroyIcon, hIconDownOn
		Invoke DestroyIcon, hIconNone
		Invoke DestroyIcon, hIconReceive
		Invoke DestroyIcon, hIconSend
		Invoke DestroyIcon, hIconUpOff
		Invoke DestroyIcon, hIconUpOn
		Invoke DestroyCursor, hCursorHand
		Invoke DestroyMenu, hMainMenu
		Invoke DestroyMenu, hTcpMenu
		Invoke DestroyMenu, hUdpMenu
		Invoke GlobalFree, lpPtr
		Invoke FreeAdaptersMemory
		.If hIpHlpApi
			Invoke FreeLibrary, hIpHlpApi
		.EndIf
	.EndIf
	Xor Rax, Rax	;Return FALSE
L4:	Ret
NetMonProcedure EndP

NetMonListView1 Proc FastCall Private Frame hWnd:HWND, uMsg:QWord, wParam:WPARAM, lParam:LPARAM
	.If uMsg == WM_VSCROLL
		.If wParam == SB_ENDSCROLL
			Mov bScrolling, FALSE
		.Else
			Mov bScrolling, TRUE
		.EndIf
	.EndIf
	Return FALSE
NetMonListView1 EndP

NetMonListView2 Proc FastCall Private Frame hWnd:HWND, uMsg:QWord, wParam:WPARAM, lParam:LPARAM
	Invoke NetMonListView1, hWnd, uMsg, wParam, lParam
	Ret
NetMonListView2 EndP

NetMonThread Proc FastCall Private Frame Uses Rbx Rdi Rsi lpParameter:LPVOID
	Mov bThreadActive, TRUE
L1: Invoke ReadIfTable, TRUE
	Invoke InitAdapterValues
	Invoke GetTickCount
	Add Rax, 500
	Mov dwCounter1, Rax
	Add Rax, 500
	Mov dwCounter2, Rax
	Mov dwCounter3, 0
	.If bRealIPAddress
		Mov bRealIPAddress, FALSE
		Invoke GetRealIP
	.EndIf
L2: Cmp bDoThread, FALSE
	Je L8
	Cmp bShowIcon, FALSE
	Jne @F
	Cmp IconData.cbSize, 0
	Je @F
	Invoke Shell_NotifyIcon, NIM_ADD, Addr IconData
	Mov bShowIcon, Rax
	Invoke RegisterWindowMessage, TextStrA("TaskbarCreated")
	Mov WM_TASKBARCREATED, Rax
	Invoke GetRealIP
@@: Invoke GetTickCount
	Cmp lAutoRefreshPorts, 0
	Je @F
	Cmp Rax, dwCounter3
	Jl @F
	Mov lpParameter, Rax
	Mov Rcx, Rax
	Mov Rax, 1000
	Mul lAutoRefreshPorts
	Add Rax, Rcx
	.If (!bScrolling)
		Mov dwCounter3, Rax
		.If bTcpPortsTab
			Invoke RefreshTcpOpenPorts, IconData.hWnd
		.ElseIf bUdpPortsTab
			Invoke RefreshUdpOpenPorts, IconData.hWnd
		.EndIf
	.EndIf
	Mov Rax, lpParameter
@@: Cmp Rax, dwCounter2
	Jge L6
	Cmp Rax, dwCounter1
	Jge L4
	Invoke SleepEx, 1, TRUE
	Jmp L2
L4: Add Rax, 500
	Mov dwCounter1, Rax
	Jmp L2
L6: Add Rax, 500
	Mov dwCounter1, Rax
	Add Rax, 500
	Mov dwCounter2, Rax
	.If dwCountDown != (-1)
		Dec dwCountDown
		Jg @F
		Invoke ShutDownPC
		Jmp L8
	.EndIf
@@:	Invoke GetIPAddressTables
	Cmp Rax, (-1)
	Je @F
	Cmp Rax, dwNumConns
	Je @F
	Invoke InitInterfaces
	Jmp L1
@@:	Invoke ReadIfTable, TRUE
	.If (!Rax)
		Invoke InitInterfaces
	.EndIf
	Invoke SetIPAddressString, (-1)
	Mov Rax, dwCurrentIndex
	Cmp Rax, (-1)
	Jne @F
	Mov dwNetState, STATUS_DISCONN
	Mov bRealIPAddress, FALSE
	Mov Rax, hIconDisconn
	Cmp Rax, IconData.hIcon
	Je L2
	Invoke SetIcons, Rax
	Jmp L2
@@: Shl Rax, 3
	Lea Rcx, dwIfTableIndex
	Add Rax, Rcx
	Mov Rbx, [Rax]
	Or Rbx, Rbx
	Jz L2

	Invoke QueryPerformanceFrequency, Addr PERFreq
	Push PERFCnt
	ECInvoke QueryPerformanceCounter, Addr PERFCnt
	Pop Rdx
	.If Rdx             ; Si EXISTE el valor anterior de PERFCnt
		Mov Rax, PERFCnt
		Sub Rax, Rdx
		.If SQWord Ptr Rax >= 0    ; SI LA DIFERENCIA ES POSITIV
			Mov Rcx, 1000000 ; microsegundos
			Mul Rcx
			Xor Rdx, Rdx
			Div PERFreq
			Mov SpeedScale, Rax   ; OK!!  se almacena el tiempo EXACTO
		.Else
			Mov SpeedScale, 0     ; Si hay problemas es CERO
		.EndIf
	.Else
		Mov SpeedScale, 0     ; Si NO EXISTE valor anterior de PERFCnt
	.EndIf

	Mov Rdi, MibIfRow2.InOctets
	Mov Rsi, MibIfRow2.OutOctets
	Invoke UpdateLights, TRUE, FALSE
	Invoke FilterData, Rdi, Addr lLastBytesInIndex, Addr lpLastBytesIn, FilterMode
	Mov [Rbx].ADAPTER_DATA.dwLastSpeedIn, Rax
	.If bCountDownActive
		.If (dwCountDown != (-1))
			Mov lpParameter, Rax
			Invoke SetCaption, dwCountDown
			Mov Rax, lpParameter
		.EndIf
		.If (Rax < SQWord Ptr dwMinBytes)
			.If dwCountDown == (-1)
				Mov Rax, lCountSeconds
				Mov dwCountDown, Rax
			.EndIf
		.Else
			Mov dwCountDown, (-1)
		.EndIf
	.Else
		Mov dwCountDown, (-1)
	.EndIf
	Invoke FilterData, Rsi, Addr lLastBytesOutIndex, Addr lpLastBytesOut, FilterMode
	Mov [Rbx].ADAPTER_DATA.dwLastSpeedOut, Rax
	Mov [Rbx].ADAPTER_DATA.dwLastBytesIn, Rdi
	Mov [Rbx].ADAPTER_DATA.dwLastBytesOut, Rsi
	Jmp L2
L8: Xor Rax, Rax
	Mov bThreadActive, Rax
	Ret
NetMonThread EndP

OnNetMonCommand Proc FastCall Private Frame hWndParent:HWND, uCtlID:QWord, uCode:QWord, hWndChild:HWND
	Local regTemp:QWord

	Mov Rax, uCtlID
	Shr Rax, 16
	.If (Rax == 0 && hWndChild == NULL)
		Mov Rax, uCtlID
		.If Rax == IDM_MENU_MONITOR
			Invoke IsWindowVisible, hWndParent
			Or Rax, Rax
			Jz @F
			Invoke SendMessage, hWndParent, WM_CLOSE, 0, 0
			Jmp L4
@@:			Invoke ShowWindow, hWndParent, SW_SHOWNORMAL
			Invoke UpdateWindow, hWndParent
			Invoke SetActiveWindow, hWndParent
			Invoke SetForegroundWindow, hWndParent
			Invoke CheckMenu, IDM_MENU_MONITOR
			Invoke wsprintfA, Addr szBuffer, Addr szFormat, BST_CHECKED
			Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szVisible, Addr szBuffer
L2:			Mov Rax, TRUE
			Jmp L4
		.ElseIf Rax == IDM_MENU_ABOUT
			Invoke CheckMainWindow, hWndParent
			Mov bModalWindowOn, TRUE
			Invoke Create, TextStr("About"), hWndParent, ecModal, NULL
			Mov bModalWindowOn, FALSE
			Jmp L2
		.ElseIf Rax == IDM_MENU_ONTOP
			Invoke CheckMenu, IDM_MENU_ONTOP
			.If Rax == MFS_CHECKED
				Mov Rdi, Rax
				Mov Rax, HWND_TOPMOST
			.Else
				Mov Rdi, MFS_UNCHECKED
				Mov Rax, HWND_NOTOPMOST
			.EndIf
			Invoke SetWindowPos, hWndParent, Rax, 0, 0, 0, 0, (SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED)
			Invoke wsprintfA, Addr szBuffer, Addr szFormat, Rdi
			Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szOnTop, Addr szBuffer
			Jmp L2
		.ElseIf Rax == IDM_MENU_SETTINGS
			Invoke CheckMainWindow, hWndParent
			Mov bModalWindowOn, TRUE
			Invoke Create, TextStr("Settings"), hWndParent, ecModal, NULL
			Mov bModalWindowOn, FALSE
			Jmp L2
		.ElseIf Rax == IDM_MENU_NETWORK
			Invoke ShellExecute, hWndParent, NULL, TextStr("CONTROL.EXE"), TextStr(" ncpa.cpl"), NULL, SW_SHOWNORMAL
			Jmp L2
		.ElseIf Rax == IDM_MENU_LOW || Rax == IDM_MENU_NORMAL || Rax == IDM_MENU_HIGH
			Mov regTemp, Rax
			Invoke CheckMenuItem, hMainSubMenu, IDM_MENU_LOW, (MF_BYCOMMAND OR MF_UNCHECKED)
			Invoke CheckMenuItem, hMainSubMenu, IDM_MENU_NORMAL, (MF_BYCOMMAND OR MF_UNCHECKED)
			Invoke CheckMenuItem, hMainSubMenu, IDM_MENU_HIGH, (MF_BYCOMMAND OR MF_UNCHECKED)
			Mov Rax, regTemp
			.If Rax == IDM_MENU_NORMAL
				Mov Rdi, NORMAL_PRIORITY_CLASS
			.ElseIf Rax == IDM_MENU_HIGH
				Mov Rdi, ABOVE_NORMAL_PRIORITY_CLASS
			.Else ; IDM_MENU_LOW
				Mov Rdi, BELOW_NORMAL_PRIORITY_CLASS
			.EndIf
			Invoke CheckMenu, Rax
			Invoke GetCurrentProcess
			Invoke SetPriorityClass, Rax, Rdi
			Invoke String, Rdi, Addr szBuffer, ecDecimal
			Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szPriority, Addr szBuffer
			Jmp L2
		.ElseIf Rax == IDM_MENU_AFFINITY
			Invoke CheckMainWindow, hWndParent
			Mov bModalWindowOn, TRUE
			Invoke Create, TextStr("Affinity"), hWndParent, ecModal, NULL
			Mov bModalWindowOn, FALSE
			Jmp L2
		.ElseIf Rax == IDM_MENU_ACTIVATE
			.If bCountDownActive
				Mov Rdx, IDS_ACTIVATE
				Xor Rax, Rax
			.Else
				Mov Rdx, IDS_DEACTIVATE
				Mov Rax, TRUE
			.EndIf
			Mov bCountDownActive, Rax
			Lea Rsi, szBuffer
			Invoke LoadAppString, Rdx, Rsi, 64
			Add Rsi, 128
			Mov [Rsi].MENUITEMINFO.cbSize, SizeOf MENUITEMINFO
			Mov [Rsi].MENUITEMINFO.fType, MFT_STRING
			Mov [Rsi].MENUITEMINFO.fMask, MIIM_TYPE
			Lea Rcx, szBuffer
			Mov [Rsi].MENUITEMINFO.dwTypeData, Rcx
			Invoke GetSubMenu, hMainMenu, 0
			Invoke SetMenuItemInfo, Rax, IDM_MENU_ACTIVATE, FALSE, Rsi
			Invoke ActivateCountDown
			Jmp L2
		.ElseIf Rax == IDM_MENU_COUNT_SETTINGS
			Invoke CheckMainWindow, hWndParent
			Mov bModalWindowOn, TRUE
			Invoke Create, TextStr("CountDown"), hWndParent, ecModal, 0
			Mov bModalWindowOn, FALSE
			.If bCountDownActive
				Invoke ActivateCountDown
			.EndIf
			Jmp L2
		.ElseIf Rax == IDM_MENU_EXIT
			Invoke CloseMonitorWindow, hWndParent, TRUE
			Invoke SendMessage, hWndParent, WM_DESTROY, 0, 0
			Jmp L4
		.Else
			.If Eax == IDM_MENU_REFRESH
				Invoke RefreshTcpOpenPorts, hWndParent
				Return TRUE
			.ElseIf Eax == IDM_MENU_REFRESH_UDP
				Invoke RefreshUdpOpenPorts, hWndParent
				Return TRUE
			.ElseIf Eax == IDM_MENU_TERMINATE_PROCESS_UDP
				Invoke SetWaitCursor, hWndParent
				Invoke GetUdpEntry, Addr szBuffer
				.If Rax
					Invoke GetCurrentProcess
					Mov Rsi, Rax
					Invoke SetPrivileges, Rsi, TRUE
					Xor Rbx, Rbx
					Lea Rdi, szBuffer
					Mov Eax, [Rdi].MIB_UDPROW_OWNER_PID.dwOwningPid
					Invoke OpenProcess, PROCESS_TERMINATE, FALSE, [Rdi].MIB_UDPROW_OWNER_PID.dwOwningPid
					.If Rax
						Mov Rbx, Rax
						Invoke TerminateProcess, Rbx, 0
					.EndIf
					.If Rbx
						Invoke CloseHandle, Rbx
						Invoke Sleep, 500
						Invoke RefreshUdpOpenPorts, hWndParent
					.EndIf
					Invoke SetPrivileges, Rsi, FALSE
				.EndIf
				Invoke SetDefaultCursor
			.Else
				.If Eax == IDM_MENU_CLOSE_PORT || Rax == IDM_MENU_TERMINATE_PROCESS || Rax == IDM_MENU_DETAILS
					Mov Rbx, Rax
					Invoke Refresh, hWndParent
					Invoke GetTcpEntry, (-1), Addr szBuffer
					.If Rax
						Invoke GetCurrentProcess
						Mov Rsi, Rax
						Invoke SetPrivileges, Rsi, TRUE
						Mov Rax, Rbx
						.If Eax == IDM_MENU_CLOSE_PORT
							Lea Rax, szBuffer
							Mov [Rax].MIB_TCPROW.dwState, MIB_TCP_STATE_DELETE_TCB
							Invoke SetTcpEntry, Addr szBuffer
							.If Rax == NO_ERROR
								Invoke Sleep, 200
								Invoke RefreshTcpOpenPorts, hWndParent
							.EndIf
						.ElseIf Eax == IDM_MENU_TERMINATE_PROCESS
							Invoke SetWaitCursor, hWndParent
							Xor Rbx, Rbx
							Lea Rdi, szBuffer
							Invoke OpenProcess, PROCESS_TERMINATE, FALSE, [Rdi].MIB_TCPROW_OWNER_PID.dwOwningPid
							.If Rax
								Mov Rbx, Rax
								Mov [Rdi].MIB_TCPROW.dwState, MIB_TCP_STATE_DELETE_TCB
								Invoke SetTcpEntry, Addr szBuffer
								Invoke TerminateProcess, Rbx, 0
							.EndIf
							.If Rbx
								Invoke CloseHandle, Rbx
								Invoke Sleep, 500
								Invoke RefreshTcpOpenPorts, hWndParent
							.EndIf
							Invoke SetDefaultCursor
						.ElseIf Eax == IDM_MENU_DETAILS
							Mov bModalWindowOn, TRUE
							Invoke Create, TextStr("Details"), hWndParent, ecModal, 0
							Mov bModalWindowOn, FALSE
						.EndIf
						Invoke SetPrivileges, Rsi, FALSE
						Return TRUE
					.EndIf
				.EndIf
			.EndIf
		.EndIf
	.ElseIf uCode == CBN_SELCHANGE
		Mov Rax, uCtlID
		.If Eax == IDC_NETMON_COMBO1
			Invoke SendMessage, hWndCombo, CB_GETCURSEL, 0, 0
			.If Rax != dwCurrentIndex
				Mov dwCurrentIndex, Rax
				Invoke SelectAdapter, (-1)
				Invoke ReadIfTable, TRUE
				Invoke InitAdapterValues
			.EndIf
			Invoke UpdateLights, TRUE, FALSE
			Invoke GetWindowItem, hWndParent, IDC_NETMON_TABSTRIP1
			Invoke SetFocus, Rax
			Return TRUE
		.EndIf
	.EndIf
	Xor Rax, Rax	;Return FALSE
L4:	Ret
OnNetMonCommand EndP

ActivateCountDown Proc FastCall Private Frame Uses Rbx
	Xor Rax, Rax
	.If bCountDownActive
		.If b10Percent
			Invoke ReadIfTable, TRUE
			Mov Rax, dwCurrentIndex
			Shl Rax, 3
			Lea Rcx, dwIfTableIndex
			Add Rax, Rcx
			Mov Rbx, [Rax]
			.If Rbx
				Mov Rax, [Rbx].ADAPTER_DATA.dwLastSpeedIn
				Mov Rcx, 10
				Xor Rdx, Rdx
				IDiv Rcx
			.Else
				Mov Rax, 100000
			.EndIf
		.Else
			Invoke lstrcpy, Addr szBuffer, TextStr("100")
			Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szMinKiloBytes, Addr szBuffer
			Invoke ValueA, Addr szBuffer
			Mov Rcx, 1024
			IMul Rcx
		.EndIf
	.EndIf
	Mov dwMinBytes, Rax
	Invoke SetCaption, lCountSeconds
	Ret
ActivateCountDown EndP

AddListViewColumn Proc FastCall Private Frame hListView:HWND, lpszText:LPSTR, lWidth:QWord, lPos:QWord, lAlignment:QWord
	Local lvc:LVCOLUMN

	Mov lvc._mask, (LVCF_FMT OR LVCF_TEXT OR LVCF_WIDTH)
	Mov Rax, lAlignment
	Mov lvc.fmt, Eax
	Mov Rax, lWidth
	Mov lvc._cx, Eax
	Mov Rax, lpszText
	Mov lvc.pszText, Rax
	Invoke lstrlen, lpszText
	Mov lvc.cchTextMax, Eax
	Mov lvc.iSubItem, 0
	Mov lvc.iImage, 0
	Mov lvc.iOrder, 0
	Invoke SendMessage, hListView, LVM_INSERTCOLUMN, lPos, Addr lvc
	Ret
AddListViewColumn EndP

CheckMainWindow Proc FastCall Private Frame hWnd:HWND
	Invoke IsWindowVisible, hWnd
	Or Rax, Rax
	Jnz @F
	Invoke SendMessage, hWnd, WM_COMMAND, IDM_MENU_MONITOR, NULL
	Invoke Sleep, 150
@@:	Cmp bSmallSize, FALSE
	Je @F
	Mov bSmallSize, FALSE
	Invoke SetMonitorSize, hWnd
@@:	Ret
CheckMainWindow EndP

CheckMenu Proc FastCall Private Frame Uses Rdi ulMenu:QWord
	Invoke GetMenuState, hMainSubMenu, ulMenu, MF_BYCOMMAND
	And Rax, MFS_CHECKED
	.If Zero?
		Mov Rax, MFS_CHECKED
	.Else
		Mov Rax, MFS_UNCHECKED
	.EndIf
	Mov Rdi, Rax
	Or Rax, MF_BYCOMMAND
	Invoke CheckMenuItem, hMainSubMenu, ulMenu, Rax
	Mov Rax, Rdi
	Ret
CheckMenu EndP

CloseMonitorWindow Proc FastCall Private Frame hWnd:QWord, bEnd:QWord
	.If bEnd
		Invoke IsWindowVisible, hWnd
	.Else
		Invoke ShowWindow, hWnd, SW_HIDE
		Invoke CheckMenu, IDM_MENU_MONITOR
		Xor Rax, Rax
	.EndIf
	Invoke wsprintfA, Addr szBuffer, Addr szFormat, Rax
	Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szVisible, Addr szBuffer
	Ret
CloseMonitorWindow EndP

CompareTcpFunction Proc FastCall Private Frame Uses Rbx Rdi Rsi lParam1:LPARAM, lParam2:LPARAM, lParamSort:LPARAM
	Local lvi:LVITEM

	Lea Rdi, szBuffer
	Add Rdi, 192
	Mov Rsi, Rdi
	Add Rsi, 16
	Mov Rax, lParamSort
	.If Rax
		Mov lvi.iSubItem, Eax
		Mov lvi._mask, LVIF_TEXT
		Mov Rax, lParam1
		Mov lvi.iItem, Eax
		Mov lvi.pszText, Rdi
		Mov lvi.cchTextMax, 12
		Invoke SendMessage, hWndLvTcp, LVM_GETITEM, 0, Addr lvi
		Mov Rax, lParam2
		Mov lvi.iItem, Eax
		Mov lvi.pszText, Rsi
		Mov lvi.cchTextMax, 12
		Invoke SendMessage, hWndLvTcp, LVM_GETITEM, 0, Addr lvi
		.If (SQWord Ptr lParamSort > 2)
			.If bStateTcpDescending
				Xchg Rdi, Rsi
			.EndIf
			Invoke lstrcmpi, Rdi, Rsi
		.Else
			.If lParamSort == 1
				Mov Rbx, bLocalTcpDescending
			.ElseIf lParamSort == 2
				Mov Rbx, bRemoteTcpDescending
			.EndIf
			Invoke ValueA, Rdi
			Mov Rdx, Rax
			Invoke ValueA, Rsi
			.If Rbx
				Xchg Rax, Rdx
			.EndIf
			Sub Rax, Rdx	;Rax < 0 = De petit a gran
		.EndIf
		Ret
	.EndIf
	Xor Rax, Rax
	Ret
CompareTcpFunction EndP

CompareUdpFunction Proc FastCall Private Frame Uses Rbx Rdi Rsi lParam1:LPARAM, lParam2:LPARAM, lParamSort:LPARAM
	Local lvi:LVITEM

	Lea Rdi, szBuffer
	Add Rdi, 192
	Mov Rsi, Rdi
	Add Rsi, 16
	Mov Rax, lParamSort
	.If Rax
		Mov lvi.iSubItem, Eax
		Mov lvi._mask, LVIF_TEXT
		Mov Rax, lParam1
		Mov lvi.iItem, Eax
		Mov lvi.pszText, Rdi
		Mov lvi.cchTextMax, 12
		Invoke SendMessage, hWndLvUdp, LVM_GETITEM, 0, Addr lvi
		Mov Rax, lParam2
		Mov lvi.iItem, Eax
		Mov lvi.pszText, Rsi
		Mov lvi.cchTextMax, 12
		Invoke SendMessage, hWndLvUdp, LVM_GETITEM, 0, Addr lvi
		.If (SQWord Ptr lParamSort > 2)
			.If bStateUdpDescending
				Xchg Rdi, Rsi
			.EndIf
			Invoke lstrcmpi, Rdi, Rsi
		.Else
			.If lParamSort == 1
				Mov Rbx, bLocalUdpDescending
			.ElseIf lParamSort == 2
				Mov Rbx, bRemoteUdpDescending
			.EndIf
			Invoke ValueA, Rdi
			Mov Rdx, Rax
			Invoke ValueA, Rsi
			.If Rbx
				Xchg Rax, Rdx
			.EndIf
			Sub Rax, Rdx	;Rax < 0 = De petit a gran
		.EndIf
		Ret
	.EndIf
	Xor Rax, Rax
	Ret
CompareUdpFunction EndP

ConvertToScale Proc FastCall Private Frame dwBytesSecond:QWord
	Mov Rax, Rcx ;dwBytesSecond
	Or Rax, Rax
	Jz L2
	Cmp Rax, 101
	Jg @F
	Mov Rax, 102
@@:	Cmp bBits, FALSE
	Je L2
	Shl Rax, 3
L2:	Ret
ConvertToScale EndP

EnableMenu Proc FastCall Private Frame hMenu:HMENU, ulID:QWord, bEnable:QWord
	Mov Rax, MF_GRAYED
	Cmp bEnable, FALSE
	Je @F
	Mov Rax, MF_ENABLED
@@:	Or Rax, MF_BYCOMMAND
	Invoke EnableMenuItem, hMenu, ulID, Rax
	Ret
EnableMenu EndP

FilterData Proc FastCall Private Frame Uses Rdi Rsi QData:QWord, BufIndxPtr:QWord, BufPtr:QWord, FMode:QWord
	Mov QData, Rcx       ; QWORD data to filter
	Mov BufIndxPtr, Rdx  ; Buffer Index Ptr
    Mov BufPtr, R8       ; Buffer Ptr
    Mov FMode, R9        ; Filter Mode: 0- NO FILTER, 1- PROMEDIO, 2- DIGITAL FILTER LOW PASS FIRST ORDER

    Mov Rdi, BufIndxPtr          ; Rdi == Index Ptr
    Mov Rcx, [Rdi]               ; Rcx == Index value
    And Rcx, 0FH                 ; Acota el valor:  "0 <=  Index <=  15"
	Mov Rsi, BufPtr

	Mov Rax, QData
	Cmp FMode, 0                 ; sin filtro
	Jz L2
	Cmp FMode, 2                 ; con filtro digital
	Jz L1
	Mov QWord Ptr [Rsi + Rcx * 8], Rax
    Cld                           ; INCREMENT STRING FUNCTIONS
    Cmp Rcx, [Rdi]                ; si son los primeros valores menores a 16, se promedian solamente esos primeros
    Jz L3                         ; si son iguales, quiere decir que Index es menor a 16.
	Mov Rcx, 16                   ; promedio con 16 valores QWORD
    Xor Rdx, Rdx                  ; suma de valores
@@: Lodsq
    Add Rdx, Rax
    Loop @B
    Shr Rdx, 4                    ; suma / 16
    Mov Rax, Rdx                  ; suma -> Rax 
	Inc QWord Ptr [Rdi]           ; Index = Index + 1
    Jmp L2
L3:     Xor Rdx, Rdx              ; Promedio de los primeros valores menores a 16
        Inc Rcx                   ; Cantidad de valores referida a "1", porque estaban referidas a "0".
        Push Rcx
@@:     Lodsq
        Add Rdx, Rax
        Loop @B
        Mov Rax, Rdx              ; Rax <- Suma
        Xor Rdx, Rdx              ; Rdx <- 0
        Pop Rcx
        Div Rcx                   ; Suma / Cantidad de valores tomados
	    Inc QWord Ptr [Rdi]       ; Index = Index + 1
L2:     Ret

;---LOW PASS FILTER FIRST ORDER - CTEFILTER == FILTER TAU == (R*C)--------------------------------------------------
L1:  Fild QWord Ptr [Rsi]                               ; Vo Ant
     Fmul CTEFILTER1                                    ; (Vo Ant) * CTEFILTER1
     Fild QWord Ptr QData                               ; Vi
     Faddp St (1), St (0)                               ; (Vo Ant) * CTEFILTER1 + Vi
     Fld1
     Fadd CTEFILTER1                                    ; 1 + CTEFILTER1
     Fdivp St (1), St (0)                               ; [(Vo Ant) * CTEFILTER1 + Vi] / (1 + CTEFILTER1)
     Frndint
     Fistp QWord Ptr [Rsi]                              ; Vo -> Vo Ant
     Mov Rax, [Rsi]                                     ; Vo -> Rax
     Jmp L2                                             ; SALIDA

FilterData EndP

FreeAdaptersMemory Proc FastCall Private Frame Uses Rbx Rdi
	Lea Rdi, dwIfTableIndex
	Mov Rbx, 64
L2:	Mov Rax, [Rdi]
	Or Rax, Rax
	Jz @F
	Invoke GlobalFree, Rax
	Mov QWord Ptr [Rdi], 0
@@:	Add Rdi, 8
	Dec Rbx
	Jnz L2
	Ret
FreeAdaptersMemory EndP

GetAppStrings Proc FastCall Private Frame Uses Rdi Rsi ulResID:QWord
	Local dqLength:QWord

	Invoke FindResource, App.Instance, ulResID, RT_FILEDATA
	.If Rax
		Mov Rdi, Rax
		Invoke SizeofResource, App.Instance, Rax
		Mov dqLength, Rax
		Invoke LoadResource, App.Instance, Rdi
		.If Rax
			Invoke LockResource, Rax
			Mov Rsi, Rax
			Mov Rax, dqLength
			Add Rax, 2
			Invoke VirtualAlloc, 0, Rax, MEM_COMMIT, PAGE_READWRITE
			Mov Rdi, Rax
			Invoke RtlMoveMemory, Rdi, Rsi, dqLength
			Xor Rax, Rax
			.While (Rax < SQWord Ptr dqLength)
				Xor Byte Ptr [Rdi + Rax], 0AAH
				Inc Rax
			.EndW
			Invoke StoreAppStrings, Rdi
			Invoke VirtualFree, Rdi, 0, MEM_RELEASE
			Ret
		.EndIf
	.EndIf
	Xor Rax, Rax
	Ret
GetAppStrings EndP

GetIPAddressTables Proc FastCall Private Frame
	Invoke GetIpAddrTable, lpPtr, Addr dwPtrSize, FALSE
	Cmp Rax, ERROR_INSUFFICIENT_BUFFER
	Jne @F
	Invoke GlobalFree, lpPtr
	Invoke GlobalAlloc, GPTR, dwPtrSize
	Mov lpPtr, Rax
	Invoke GetIpAddrTable, lpPtr, Addr dwPtrSize, FALSE
@@:	Cmp Rax, NO_ERROR
	Je @F
	Mov Rax, (-1)
	Ret
@@:	Mov Rax, lpPtr
	Mov Eax, [Rax]	;Rax = Number of entries
	Ret
GetIPAddressTables EndP

GetMeterRegistrySettings Proc FastCall Private Frame
	Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szBits, Addr szBuffer
	.If Rax
		Invoke ValueA, Addr szBuffer
		Mov bBits, Rax
	.EndIf
	Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szFilterMode, Addr szBuffer
	.If Rax
		Invoke ValueA, Addr szBuffer
		Mov FilterMode, Rax
	.EndIf
	Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szKBValue, Addr szBuffer
	.If Rax
		Invoke ValueA, Addr szBuffer
		.If (Rax != 1000 && Rax != 1024)
			Mov Rax, 1024
		.EndIf
		Mov KBValue, Rax
	.EndIf
	Invoke SetKBValues
	Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szMeterDownColor, Addr szBuffer
	.If Rax
		Invoke ValueA, Addr szBuffer
		Mov crMeterDownColor, Eax
	.EndIf
	Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szMeterUpColor, Addr szBuffer
	.If Rax
		Invoke ValueA, Addr szBuffer
		Mov crMeterUpColor, Eax
	.EndIf
	Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szMeterDownMaxValueEnum, Addr szBuffer
	.If Rax
		Invoke ValueA, Addr szBuffer
		Mov lMeterDownMaxValueEnum, Rax
	.EndIf
	Invoke CheckMeterMaxValue, lMeterDownMaxValueEnum, Addr lMeterDownMaxValue
	Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szMeterUpMaxValueEnum, Addr szBuffer
	.If Rax
		Invoke ValueA, Addr szBuffer
		Mov lMeterUpMaxValueEnum, Rax
	.EndIf
	Invoke CheckMeterMaxValue, lMeterUpMaxValueEnum, Addr lMeterUpMaxValue
	Ret
GetMeterRegistrySettings EndP

GetRealIP Proc FastCall Private Frame Uses Rsi
	Local dwParameter:QWord

	.If (!bRealIPAddress)
		Invoke CreateThread, 0, 0, Addr RemoteIPThread, Addr dwParameter, 0, NULL
		Invoke CloseHandle, Rax
	.EndIf
	Ret
GetRealIP EndP

GetSpeedString Proc FastCall Private Frame Uses Rsi dwValue:QWord, dwDiv1:QWord, dwDiv2:QWord
	Mov Rax, dwValue
	Xor Rdx, Rdx
	Div dwDiv1
	Mov Rsi, Rdx
	Invoke wsprintfA, Addr szBuffer, Addr szFormat, Rax
	Invoke lstrlen, Addr szBuffer
	Xchg Rax, Rsi
	Lea Rcx, szBuffer
	Add Rsi, Rcx
	Xor Rdx, Rdx
	Div dwDiv2
	Cmp Rax, 10
	Jl @F
	Mov Rax, 9
@@:	Mov Cl, [sDecimal]
	Mov Byte Ptr [Rsi], Cl
	Inc Rsi
	Invoke wsprintfA, Rsi, Addr szFormat, Rax
	Ret
GetSpeedString EndP

GetTcpEntry Proc FastCall Private Frame Uses Rbx Rdi Rsi lItem:QWord, lpMibTcpRow:QWord
	Local hMem:QWord, lvi:LVITEM

	Mov Rdi, lpMibTcpRow
	Mov Rax, lItem
	.If Rax == (-1)
		Invoke SendMessage, hWndLvTcp, LVM_GETNEXTITEM, (-1), LVNI_SELECTED
	.EndIf
	.If (Rax != (-1))
		Mov lvi.iItem, Eax
		Mov lvi._mask, LVIF_TEXT
		Mov lvi.iSubItem, 1
		Lea Rax, szBuffer
		Mov lvi.pszText, Rax
		Mov lvi.cchTextMax, 12
		Invoke SendMessage, hWndLvTcp, LVM_GETITEM, 0, Addr lvi
		Invoke ValueA, Addr szBuffer
		Mov Rbx, Rax
		Inc lvi.iSubItem
		Invoke SendMessage, hWndLvTcp, LVM_GETITEM, 0, Addr lvi
		Invoke ValueA, Addr szBuffer
		Mov Rsi, Rax
		Invoke ReadTcpTableEx
		Mov Rdx, Rsi
		Mov Rcx, Rbx
		.If Rax
			Mov Rsi, Rax
			Mov hMem, Rax
			Xchg Cl, Ch
			Xchg Dl, Dh
			Mov Ebx, [Rsi]
			Add Rsi, SizeOf DWord
			.While Rbx
				.If Ecx == [Rsi].MIB_TCPROW_OWNER_PID.dwLocalPort && Edx == [Rsi].MIB_TCPROW_OWNER_PID.dwRemotePort
					Mov [Rdi].MIB_TCPROW_OWNER_PID.dwLocalPort, Ecx
					Mov [Rdi].MIB_TCPROW_OWNER_PID.dwRemotePort, Edx
					Mov Eax, [Rsi].MIB_TCPROW_OWNER_PID.dwState
					Mov [Rdi].MIB_TCPROW_OWNER_PID.dwState, Eax
					Mov Eax, [Rsi].MIB_TCPROW_OWNER_PID.dwLocalAddr
					Mov [Rdi].MIB_TCPROW_OWNER_PID.dwLocalAddr, Eax
					Mov Eax, [Rsi].MIB_TCPROW_OWNER_PID.dwRemoteAddr
					Mov [Rdi].MIB_TCPROW_OWNER_PID.dwRemoteAddr, Eax
					Mov [Rdi].MIB_TCPROW_OWNER_PID.dwOwningPid, (-1)
					.If lpGetExtendedTcpTable
						Mov Eax, [Rsi].MIB_TCPROW_OWNER_PID.dwOwningPid
						Mov [Rdi].MIB_TCPROW_OWNER_PID.dwOwningPid, Eax
					.EndIf
					Invoke GlobalFree, hMem
					Mov Rax, TRUE
					Ret
				.EndIf
				Add Rsi, SizeOf MIB_TCPROW_OWNER_PID
				Dec Rbx
			.EndW
			Invoke GlobalFree, hMem
		.EndIf
	.EndIf
	Xor Rax, Rax
	Ret
GetTcpEntry EndP

GetTcpOpenPorts Proc FastCall Private Frame Uses Rbx Rdi Rsi
	Local lp:LPVOID, lvi:LVITEM

	Invoke SendMessage, hWndLvTcp, LVM_DELETEALLITEMS, 0, 0
	Invoke ReadTcpTableEx
	.If Rax
		Mov lp, Rax
		Mov Rsi, Rax
		Mov lvi._mask, LVIF_TEXT
		Xor Rdi, Rdi
		Mov Ebx, [Rsi]
		Add Rsi, SizeOf DWord
		Lea Rax, szBuffer
		Mov lvi.pszText, Rax
		.While Ebx
			Mov Word Ptr szBuffer [0], 0
			Mov lvi.iItem, Edi
			Mov lvi.iSubItem, 0
			Mov lvi.cchTextMax, 1
			Invoke SendMessage, hWndLvTcp, LVM_INSERTITEM, 0, Addr lvi
			Mov lvi.iItem, Eax
			Inc lvi.iSubItem
			Mov Eax, [Rsi].MIB_TCPROW_OWNER_PID.dwLocalPort
			Invoke PortToStr, Rax, Addr szBuffer
			Invoke SendMessage, hWndLvTcp, LVM_SETITEM, 0, Addr lvi
			Inc lvi.iSubItem
			Mov Eax, [Rsi].MIB_TCPROW_OWNER_PID.dwRemotePort
			Invoke PortToStr, Rax, Addr szBuffer
			Invoke SendMessage, hWndLvTcp, LVM_SETITEM, 0, Addr lvi
			Inc lvi.iSubItem
			Mov Eax, [Rsi].MIB_TCPROW_OWNER_PID.dwState
			Invoke GetStateString, Rax, Addr szBuffer
			Invoke SendMessage, hWndLvTcp, LVM_SETITEM, 0, Addr lvi
			Add Rsi, SizeOf MIB_TCPROW_OWNER_PID
			Inc Rdi
			Dec Ebx
		.EndW
		Invoke GlobalFree, lp
		Invoke SendMessage, hWndLvTcp, LVM_SORTITEMSEX, lCurrentTcpSort, Addr CompareTcpFunction
	.EndIf
	Ret
GetTcpOpenPorts EndP

GetUdpEntry Proc FastCall Private Frame Uses Rbx Rdi Rsi lpMibUdpRow:QWord
	Local hMem:QWord, lvi:LVITEM

	Mov Rdi, lpMibUdpRow
	Invoke SendMessage, hWndLvUdp, LVM_GETNEXTITEM, (-1), LVNI_SELECTED
	.If (Rax != (-1))
		Mov lvi.iItem, Eax
		Mov lvi._mask, LVIF_TEXT
		Mov lvi.iSubItem, 1
		Lea Rax, szBuffer
		Mov lvi.pszText, Rax
		Mov lvi.cchTextMax, 16
		Invoke SendMessage, hWndLvUdp, LVM_GETITEM, 0, Addr lvi
		Invoke ValueA, Addr szBuffer
		Mov Rbx, Rax
		Inc lvi.iSubItem
		Invoke SendMessage, hWndLvUdp, LVM_GETITEM, 0, Addr lvi
		Invoke StrToIP, Addr szBuffer
		Mov Rsi, Rax
		Invoke ReadUdpTableEx
		Mov Rdx, Rsi
		Mov Rcx, Rbx
		.If Rax
			Mov Rsi, Rax
			Mov hMem, Rax
			Xchg Cl, Ch
			Mov Ebx, [Rsi]
			Add Rsi, SizeOf DWord
			.While Rbx
				.If Ecx == [Rsi].MIB_UDPROW_OWNER_PID.dwLocalPort && Edx == [Rsi].MIB_UDPROW_OWNER_PID.dwLocalAddr
					Mov [Rdi].MIB_UDPROW_OWNER_PID.dwLocalAddr, Edx
					Mov [Rdi].MIB_UDPROW_OWNER_PID.dwLocalPort, Ecx
					.If lpGetExtendedUdpTable
						Mov Eax, [Rsi].MIB_UDPROW_OWNER_PID.dwOwningPid
						Mov [Rdi].MIB_UDPROW_OWNER_PID.dwOwningPid, Eax
					.EndIf
					Invoke GlobalFree, hMem
					Mov Rax, TRUE
					Ret
				.EndIf
				Add Rsi, SizeOf MIB_UDPROW_OWNER_PID
				Dec Rbx
			.EndW
			Invoke GlobalFree, hMem
		.EndIf
	.EndIf
	Xor Rax, Rax
	Ret
GetUdpEntry EndP

GetUdpOpenPorts Proc FastCall Private Frame Uses Rbx Rdi Rsi
	Local lp:LPVOID, lvi:LVITEM
	Local ProcessEntry:PROCESSENTRY32

	Invoke SendMessage, hWndLvUdp, LVM_DELETEALLITEMS, 0, 0
	Invoke ReadUdpTableEx
	.If Rax
		Mov lp, Rax
		Mov Rsi, Rax
		Mov lvi._mask, LVIF_TEXT
		Xor Rdi, Rdi
		Mov Ebx, [Rsi]
		Add Rsi, SizeOf DWord
		Lea Rax, szBuffer
		Mov lvi.pszText, Rax
		.While Ebx
			Mov Word Ptr szBuffer [0], 0
			Mov lvi.iItem, Edi
			Mov lvi.iSubItem, 0
			Invoke SendMessage, hWndLvUdp, LVM_INSERTITEM, 0, Addr lvi
			Mov lvi.iItem, Eax
			Inc lvi.iSubItem
			Mov Eax, [Rsi].MIB_UDPROW_OWNER_PID.dwLocalPort
			Invoke PortToStr, Rax, Addr szBuffer
			Invoke SendMessage, hWndLvUdp, LVM_SETITEM, 0, Addr lvi
			Inc lvi.iSubItem
			Mov Eax, [Rsi].MIB_UDPROW_OWNER_PID.dwLocalAddr
			Invoke IPToStr, Rax, Addr szBuffer
			Invoke SendMessage, hWndLvUdp, LVM_SETITEM, 0, Addr lvi
			Inc lvi.iSubItem
			Mov Rdx, (-1)
			.If lpGetExtendedUdpTable
				Mov Edx, [Rsi].MIB_UDPROW_OWNER_PID.dwOwningPid
			.EndIf
			Invoke GetProcessInfo, Rdx, Addr szBuffer, Addr ProcessEntry
			Invoke SendMessage, hWndLvUdp, LVM_SETITEM, 0, Addr lvi
			Add Rsi, SizeOf MIB_UDPROW_OWNER_PID
			Inc Rdi
			Dec Ebx
		.EndW
		Invoke GlobalFree, lp
		Invoke SendMessage, hWndLvUdp, LVM_SORTITEMSEX, lCurrentUdpSort, Addr CompareUdpFunction
	.EndIf
	Ret
GetUdpOpenPorts EndP

InitAdapterValues Proc FastCall Private Frame Uses Rbx
	Mov Rax, dwCurrentIndex
	Cmp Rax, (-1)
	Jne @F
	Ret
@@:	Shl Rax, 3
	Lea Rcx, dwIfTableIndex
	Add Rax, Rcx
	Mov Rbx, [Rax]		;Get adapter data address
	Invoke UpdateBytes, TRUE
	Invoke UpdateSpeed, 0, IDC_NETMON_STCSPEEDIN, Addr [Rbx].ADAPTER_DATA.dwLastSpeedIn, TRUE
	Invoke UpdateSpeed, 0, IDC_NETMON_STCSPEEDOUT, Addr [Rbx].ADAPTER_DATA.dwLastSpeedOut, TRUE
	Invoke SetIPAddressString, Rbx
	Mov Rax, MibIfRow2.InOctets
	Mov [Rbx].ADAPTER_DATA.dwLastSpeedIn, Rax
	Or Rax, Rax
	Jz @F
	Dec Rax
@@:	Mov [Rbx].ADAPTER_DATA.dwLastBytesIn, Rax
	Mov Rax, MibIfRow2.OutOctets
	Mov [Rbx].ADAPTER_DATA.dwLastSpeedOut, Rax
	Or Rax, Rax
	Jz @F
	Dec Rax
@@:	Mov [Rbx].ADAPTER_DATA.dwLastBytesOut, Rax
	Ret
InitAdapterValues EndP

InitInterfaces Proc FastCall Private Frame Uses Rbx Rdi Rsi
	Local regTemp:QWord

	Xor Rbx, Rbx
	Invoke FreeAdaptersMemory
	Lea Rdi, dwIfTableIndex
	Invoke SendMessage, hWndCombo, CB_RESETCONTENT, 0, 0
	Cmp dwCurrentIndex, (-1)
	Jne @F
	Mov dwCurrentIndex, 0
@@:	Invoke GetIPAddressTables
	Cmp Rax, (-1)
	Je L4
	Mov Rsi, lpPtr
	Mov Rcx, Rax	;Rcx = Number of entries
	Mov dwNumConns, Rax
	Add Rsi, SizeOf DWord
	Lea Rsi, [Rsi]	;Rsi = Pointer to first MIB_IPADDRROW struct
L2:	Mov regTemp, Rcx
	Invoke RtlZeroMemory, Addr MibIfRow2, SizeOf MibIfRow2
	Mov Eax, [Rsi].MIB_IPADDRROW.dwIndex
	Mov MibIfRow2.InterfaceIndex, Eax
	Invoke GetIfEntry2, Addr MibIfRow2
	.If MibIfRow2._Type != MIB_IF_TYPE_LOOPBACK || dwNumConns < 2
		Invoke GlobalAlloc, GPTR, SizeOf ADAPTER_DATA
		Mov Rdx, Rax
		Cmp MibIfRow2.InOctets, 0
		Je @F
		Or Rbx, Rbx
		Jnz @F
		Mov Rax, Rdi
		Lea Rcx, dwIfTableIndex
		Sub Rax, Rcx
		Shr Rax, 3
		Mov dwCurrentIndex, Rax
		Mov Rbx, TRUE
@@:		Mov [Rdi], Rdx
		Mov Eax, MibIfRow2.InterfaceIndex
		Mov [Rdx].ADAPTER_DATA.dwIndex, Rax
		Mov Eax, MibIfRow2._Type
		Mov [Rdx].ADAPTER_DATA.dwType, Rax
		Mov Eax, [Rsi].MIB_IPADDRROW.dwAddr
		Mov [Rdx].ADAPTER_DATA.dwAddress, Rax
		Mov Eax, [Rsi].MIB_IPADDRROW.dwMask
		Mov [Rdx].ADAPTER_DATA.dwMask, Rax
		Add Rdi, 8
		Invoke WideCharToMultiByte, CP_ACP, 0, Addr MibIfRow2.Description, (-1), Addr szBuffer, 64, NULL, NULL
		Invoke SendMessageA, hWndCombo, CB_ADDSTRING, 0, Addr szBuffer
		Invoke SendMessageA, hWndCombo, CB_GETCOUNT, 0, 0
	.EndIf
	Add Rsi, SizeOf MIB_IPADDRROW
	Mov Rcx, regTemp
	Dec Rcx
	Jnz L2
	Invoke SelectAdapter, (-1)
	Mov Rax, NO_ERROR
L4:	Ret
InitInterfaces EndP

ReadIfTable Proc FastCall Private Frame Uses Rbx bCheckNet:QWord
	Local bReturn:QWord

	Mov bReturn, FALSE
	Mov Rax, dwCurrentIndex
	Cmp Rax, (-1)
	Jne @F
	Xor Rax, Rax
@@:	Shl Rax, 3
	Lea Rcx, dwIfTableIndex
	Add Rax, Rcx
	Mov Rbx, [Rax]
	Or Rbx, Rbx
	Jnz @F
	Mov dwCurrentIndex, (-1)
L1:	Invoke SelectAdapter, (-1)

	Mov Rax, hIconDisconn
	Jmp L4
@@:	Cmp [Rbx].ADAPTER_DATA.dwType, MIB_IF_TYPE_LOOPBACK
	Je L1
	Mov Rax, [Rbx].ADAPTER_DATA.dwIndex
	Mov MibIfRow2.InterfaceIndex, Eax
	Mov Rax, MibIfRow2.ReceiveLinkSpeed
	Invoke SelectAdapter, Rax
	Cmp Rax, NO_ERROR
	Jne @F
	.If (MibIfRow2.OperStatus == IfOperStatusUp)
		Mov bReturn, TRUE
	.EndIf
@@:	Cmp bCheckNet, FALSE
	Je @F
	.If bReturn
		Cmp dwNetState, STATUS_DISCONN
		Jne @F
		Mov dwNetState, STATUS_NONE
		Mov Rax, hIconNone
	.Else
		Cmp dwNetState, STATUS_DISCONN
		Je @F
		Mov dwNetState, STATUS_DISCONN
		Mov Rax, hIconDisconn
	.EndIf
L4:	Cmp Rax, IconData.hIcon
	Je @F
	Invoke SetIcons, Rax
@@:	Mov Rax, bReturn
	Ret
ReadIfTable EndP

RefreshTcpOpenPorts Proc FastCall Private Frame Uses Rbx Rdi Rsi hWnd:HWND
	Local lTopIndex:QWord, rc:RECT, lvi:LVITEM

	Cmp bRefreshingTcp, FALSE
	Je @F
	Ret
@@:	Mov bRefreshingTcp, TRUE
	Invoke SetWaitCursor, hWnd
	Invoke GetWindowItem, hWnd, IDC_NETMON_GRPLISTVIEW
	Mov Rdi, Rax
	Invoke SendMessage, hWndLvTcp, LVM_GETTOPINDEX, 0, 0
	Mov lTopIndex, Rax
	Invoke SendMessage, hWndLvTcp, LVM_GETNEXTITEM, (-1), LVNI_SELECTED
	Cmp Rax, (-1)
	Jne @F
	Xor Rax, Rax
@@:	Mov lvi.iItem, Eax
	Invoke SendMessage, hWndLvTcp, LVM_GETITEMCOUNT, 0, 0
	Mov Rbx, Rax
	Invoke SendMessage, Rdi, WM_SETREDRAW, FALSE, 0
	Invoke GetTcpOpenPorts
	Invoke SendMessage, hWndLvTcp, LVM_GETITEMCOUNT, 0, 0
	Mov Rsi, Rax
	Cmp Eax, lvi.iItem
	Jg @F
	Dec Rax
	Mov lvi.iItem, Eax
@@:	Mov lvi._mask, LVIF_STATE
	Mov lvi.iSubItem, 0
	Mov lvi.state, (LVIS_FOCUSED Or LVIS_SELECTED)
	Mov lvi.stateMask, (LVIS_FOCUSED Or LVIS_SELECTED)
	Invoke SendMessage, hWndLvTcp, LVM_SETITEM, 0, Addr lvi
	Mov rc.left, LVIR_BOUNDS
	Invoke SendMessage, hWndLvTcp, LVM_GETITEMRECT, 0, Addr rc
	Mov Eax, rc.top
	Sub rc.bottom, Eax
	Xor Rdx, Rdx
	Mov Rax, lTopIndex
	Mul rc.bottom
	Invoke SendMessage, hWndLvTcp, LVM_SCROLL, 0, Rax
	Invoke SetFocus, hWndLvTcp
	Invoke SetDefaultCursor
	Invoke SendMessage, Rdi, WM_SETREDRAW, TRUE, 0
	.If Rbx == Rsi
		Invoke InvalidateRect, hWndLvTcp, NULL, FALSE
	.Else
		Invoke RedrawWindow, Rdi, NULL, NULL, (RDW_ERASE Or RDW_INVALIDATE Or RDW_UPDATENOW Or RDW_ALLCHILDREN)
	.EndIf
	Mov bRefreshingTcp, FALSE
	Ret
RefreshTcpOpenPorts EndP

ReadTcpTableEx Proc FastCall Private Frame Uses Rdi Rsi
	Local dwSize:QWord

	Invoke GetCurrentProcess
	Mov Rdi, Rax
	Invoke SetPrivileges, Rdi, TRUE

	Xor Rsi, Rsi
	Mov Rax, lpGetExtendedTcpTable
	Or Rax, Rax
	Je L4
	Mov dwSize, SizeOf MIB_TCPROW_OWNER_PID
	Invoke GlobalAlloc, GPTR, dwSize
	Mov Rsi, Rax
	Invoke GetExtendedTcpTable, Rsi, Addr dwSize, TRUE, AF_INET, TCP_TABLE_OWNER_PID_ALL, 0
	Cmp Rax, NO_ERROR
	Je L2
	Cmp Rax, ERROR_INSUFFICIENT_BUFFER
	Jne L4
	Invoke GlobalFree, Rsi
	Invoke GlobalAlloc, GPTR, dwSize
	Mov Rsi, Rax
L2:	Invoke GetExtendedTcpTable, Rsi, Addr dwSize, TRUE, AF_INET, TCP_TABLE_OWNER_PID_ALL, 0
	Cmp Rax, NO_ERROR
	Je L8
L4:	Or Rsi, Rsi
	Jz @F
	Invoke GlobalFree, Rsi
@@:	Mov lpGetExtendedTcpTable, NULL
	Mov dwSize, SizeOf MIB_TCPROW_OWNER_PID
	Invoke GlobalAlloc, GPTR, dwSize
	Mov Rsi, Rax
	Invoke GetTcpTable, Rsi, Addr dwSize, FALSE
	Cmp Rax, NO_ERROR
	Je L6
	Cmp Rax, ERROR_INSUFFICIENT_BUFFER
	Je @F
	Invoke GlobalFree, Rsi
	Xor Rax, Rax
	Jmp L10
@@:	Invoke GlobalFree, Rsi
	Invoke GlobalAlloc, GPTR, dwSize
	Mov Rsi, Rax
L6:	Invoke GetTcpTable, Rsi, Addr dwSize, FALSE
	Cmp Rax, NO_ERROR
	Je L8
	Invoke GlobalFree, Rsi
	Xor Rax, Rax
	Jmp L10
L8:	Mov Rax, Rsi

L10:
	Mov dwSize, Rax
	Invoke SetPrivileges, Rdi, FALSE
	Mov Rax, dwSize
	Ret
ReadTcpTableEx EndP

ReadUdpTableEx Proc FastCall Private Frame Uses Rdi Rsi
	Local dwSize:QWord

	Invoke GetCurrentProcess
	Mov Rdi, Rax
	Invoke SetPrivileges, Rdi, TRUE

	Xor Rsi, Rsi
	Mov Rax, lpGetExtendedUdpTable
	Or Rax, Rax
	Je L4
	Mov dwSize, SizeOf MIB_UDPROW_OWNER_PID
	Invoke GlobalAlloc, GPTR, dwSize
	Mov Rsi, Rax
	Invoke GetExtendedUdpTable, Rsi, Addr dwSize, TRUE, AF_INET, UDP_TABLE_OWNER_PID, 0
	Cmp Rax, NO_ERROR
	Je L2
	Cmp Rax, ERROR_INSUFFICIENT_BUFFER
	Jne L4
	Invoke GlobalFree, Rsi
	Invoke GlobalAlloc, GPTR, dwSize
	Mov Rsi, Rax
L2:	Invoke GetExtendedUdpTable, Rsi, Addr dwSize, TRUE, AF_INET, UDP_TABLE_OWNER_PID, 0
	Cmp Rax, NO_ERROR
	Je L8
L4:	Or Rsi, Rsi
	Jz @F
	Invoke GlobalFree, Rsi
@@:	Mov lpGetExtendedUdpTable, NULL
	Mov dwSize, SizeOf MIB_UDPROW
	Invoke GlobalAlloc, GPTR, dwSize
	Mov Rsi, Rax
	Invoke GetUdpTable, Rsi, Addr dwSize, FALSE
	Cmp Rax, NO_ERROR
	Je L6
	Cmp Rax, ERROR_INSUFFICIENT_BUFFER
	Je @F
	Invoke GlobalFree, Rsi
	Xor Rax, Rax
	Jmp L10
@@:	Invoke GlobalFree, Rsi
	Invoke GlobalAlloc, GPTR, dwSize
	Mov Rsi, Rax
L6:	Invoke GetUdpTable, Rsi, Addr dwSize, FALSE
	Cmp Rax, NO_ERROR
	Je L8
	Invoke GlobalFree, Rsi
	Xor Rax, Rax
	Jmp L10
L8:	Mov Rax, Rsi

L10:
	Mov dwSize, Rax
	Invoke SetPrivileges, Rdi, FALSE
	Mov Rax, dwSize
	Ret
ReadUdpTableEx EndP

RefreshUdpOpenPorts Proc FastCall Private Frame Uses Rbx Rdi Rsi hWnd:HWND
	Local lTopIndex:QWord, rc:RECT, lvi:LVITEM

	Cmp bRefreshingUdp, FALSE
	Je @F
	Ret
@@:	Mov bRefreshingUdp, TRUE
	Invoke SetWaitCursor, hWnd
	Invoke GetWindowItem, hWnd, IDC_NETMON_GRPLISTVIEW
	Mov Rdi, Rax
	Invoke SendMessage, hWndLvUdp, LVM_GETTOPINDEX, 0, 0
	Mov lTopIndex, Rax
	Invoke SendMessage, hWndLvUdp, LVM_GETNEXTITEM, (-1), LVNI_SELECTED
	Cmp Rax, (-1)
	Jne @F
	Xor Rax, Rax
@@:	Mov lvi.iItem, Eax
	Invoke SendMessage, hWndLvTcp, LVM_GETITEMCOUNT, 0, 0
	Mov Rbx, Rax
	Invoke SendMessage, Rdi, WM_SETREDRAW, FALSE, 0
	Invoke GetUdpOpenPorts
	Invoke SendMessage, hWndLvUdp, LVM_GETITEMCOUNT, 0, 0
	Mov Rsi, Rax
	Cmp Eax, lvi.iItem
	Jg @F
	Dec Rax
	Mov lvi.iItem, Eax
@@:	Mov lvi._mask, LVIF_STATE
	Mov lvi.iSubItem, 0
	Mov lvi.state, (LVIS_FOCUSED Or LVIS_SELECTED)
	Mov lvi.stateMask, (LVIS_FOCUSED Or LVIS_SELECTED)
	Invoke SendMessage, hWndLvUdp, LVM_SETITEM, 0, Addr lvi
	Mov rc.left, LVIR_BOUNDS
	Invoke SendMessage, hWndLvUdp, LVM_GETITEMRECT, 0, Addr rc
	Mov Eax, rc.top
	Sub rc.bottom, Eax
	Xor Rdx, Rdx
	Mov Rax, lTopIndex
	Mul rc.bottom
	Invoke SendMessage, hWndLvUdp, LVM_SCROLL, 0, Rax
	Invoke SetFocus, hWndLvUdp
	Invoke SetDefaultCursor
	Invoke SendMessage, Rdi, WM_SETREDRAW, TRUE, 0
	.If Rbx == Rsi
		Invoke InvalidateRect, hWndLvUdp, NULL, FALSE
	.Else
		Invoke RedrawWindow, Rdi, NULL, NULL, (RDW_ERASE Or RDW_INVALIDATE Or RDW_UPDATENOW Or RDW_ALLCHILDREN)
	.EndIf
	Mov bRefreshingUdp, FALSE
	Ret
RefreshUdpOpenPorts EndP

RemoteIPThread Proc FastCall Private Frame Uses Rbx Rdi Rsi lpParameter:LPVOID
	Local hOpen:HANDLE, hFile:HANDLE, hLabel:HANDLE
	Local dwBytesRead:SQWord, sBuffer[128]:Byte

	Invoke SetWaitCursor, App.Main
	Invoke GetWindowItem, App.Main, IDC_NETMON_STCREALIP
	Mov hLabel, Rax
	Invoke LoadAppString, IDS_CONNECTING, Addr szBuffer, 64
	Invoke SetText, hLabel, Addr szBuffer
	Invoke InternetOpen, TextStr("IE"), INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0
	Or Rax, Rax
	Jz @F
	Mov hOpen, Rax

	Invoke InternetOpenUrl, hOpen, TextStr("http://checkip.dyndns.org"), 0, 0, INTERNET_FLAG_RELOAD, 0
	.If Rax == 0
		Invoke InternetCloseHandle, hOpen
		Xor Rax, Rax
		Jmp @F
	.EndIf
	Mov hFile, Rax
	Mov dwBytesRead, 0
	Lea Rsi, sBuffer
	Invoke RtlZeroMemory, Rsi, SizeOf sBuffer
	Invoke InternetReadFile, hFile, Rsi, (SizeOf sBuffer - 2), Addr dwBytesRead
	Invoke InternetCloseHandle, hFile
	Invoke InternetCloseHandle, hOpen
	.If (dwBytesRead > 0) && (dwBytesRead < SizeOf sBuffer)
		Invoke FindStringA, Rsi, TextStrA("</body>"), 0
		.If Rax != (-1)
			Add Rax, Rsi
			Mov Word Ptr [Rax], 0
			Invoke FindCharRevA, Rsi, VK_SPACE
			.If Rax != (-1)
				Inc Rax
				Add Rsi, Rax
			.EndIf
		.EndIf
		Invoke SetTextA, hLabel, Rsi
		Mov Rax, TRUE
	.EndIf
@@:	.If Rax == 0
		Invoke SetText, hLabel, TextStr("?")
	.EndIf
	Mov bRealIPAddress, TRUE
	Invoke SetDefaultCursor
	Ret
RemoteIPThread EndP

SaveMonitorPosition Proc FastCall Private Frame Uses Rbx Rdi Rsi hWnd:HWND
	Local wp:WINDOWPLACEMENT

	Mov wp._length, SizeOf WINDOWPLACEMENT
	Invoke GetWindowPlacement, hWnd, Addr wp
	Lea Rbx, rcLarge
	Lea Rdi, szLeft
	Lea Rsi, szTop
	Cmp bSmallSize, FALSE
	Je @F
	Lea Rbx, rcSmall
	Lea Rdi, szSmallLeft
	Lea Rsi, szSmallTop
@@:	Mov Eax, wp.rcNormalPosition.left
	Mov [Rbx].RECT.left, Eax
	Invoke wsprintfA, Addr szBuffer, Addr szFormat, Rax
	Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Rdi, Addr szBuffer
	Mov Eax, wp.rcNormalPosition.top
	Mov [Rbx].RECT.top, Eax
	Invoke wsprintfA, Addr szBuffer, Addr szFormat, Rax
	Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Rsi, Addr szBuffer
	Ret
SaveMonitorPosition EndP

SelectAdapter Proc FastCall Private Frame Uses Rdi Rbx dwNetSpeed:QWord
	Local regTemp:QWord

	Cmp dwNetSpeed, (-1)
	Jne L2
	Invoke SendMessage, hWndCombo, CB_SETCURSEL, dwCurrentIndex, 0
	Cmp Rax, CB_ERR
	Jne @F
	Mov dwCurrentIndex, (-1)
	Invoke lstrcpy, Addr IconData.szTip, App.Header
	Jmp L4
@@:	Mov Rax, dwCurrentIndex
	Shl Rax, 3
	Lea Rcx, dwIfTableIndex
	Add Rax, Rcx
	Mov Rax, [Rax]		;Get adapter data address
	Or Rax, Rax
	Jz L2
	Mov Rax, [Rax].ADAPTER_DATA.dwIndex
	Mov MibIfRow2.InterfaceIndex, Eax
L2:	Mov Edi, MibIfRow2.InterfaceIndex
	Invoke RtlZeroMemory, Addr MibIfRow2, SizeOf MibIfRow2
	Mov MibIfRow2.InterfaceIndex, Edi
	Invoke GetIfEntry2, Addr MibIfRow2
	Mov regTemp, Rax
	Mov Rax, dwNetSpeed
	.If Rax != MibIfRow2.ReceiveLinkSpeed
		Mov Rbx, IDS_KBITS
		Mov Rdx, 1000
		Mov Rax, 100
		Cmp MibIfRow2.ReceiveLinkSpeed, 999999
		Jbe @F
		Mov Rbx, IDS_MBITS
		Mov Rdx, 1000000
		Mov Rax, 100000
		Cmp MibIfRow2.ReceiveLinkSpeed, 999999999
		Jbe @F
		Mov Rbx, IDS_GBITS
		Mov Rdx, 1000000000
		Mov Rax, 100000000
@@:		Invoke GetSpeedString, MibIfRow2.ReceiveLinkSpeed, Rdx, Rax
		Invoke lstrlen, Addr szBuffer
		Lea Rcx, szBuffer
		Add Rax, Rcx
		Mov Byte Ptr [Rax], VK_SPACE
		Inc Rax
		Invoke LoadAppString, Rbx, Rax, 12
		Invoke SetControlText, IDC_NETMON_STCNETSPEED, Addr szBuffer
		Invoke LoadAppString, IDS_SPEED, Addr IconData.szTip, 64
		Lea Rcx, IconData.szTip
		Add Rax, Rcx
		Mov Byte Ptr [Rax], VK_SPACE
		Inc Rax
		Invoke lstrcpy, Rax, Addr szBuffer
	.EndIf
	Mov Rax, regTemp
L4:	Ret
SelectAdapter EndP

SetCaption Proc FastCall Private Frame Uses Rsi lCountDown:QWord
	Lea Rsi, szBuffer
	Invoke lstrcpy, Rsi, App.Header
	.If bCountDownActive
		Invoke lstrlen, Rsi
		Add Rsi, Rax
		Mov Byte Ptr [Rsi], ' '
		Mov Byte Ptr [Rsi + 1], '('
		Add Rsi, 2
		Invoke String, lCountDown, Rsi, ecDecimal
		Add Rsi, Rax
		Mov Byte Ptr [Rsi], 's'
		Mov Byte Ptr [Rsi + 1], 0
		Invoke lstrcat, Rsi, TextStrA(" / ", 41)
		Add Rsi, 4
		Xor Rdx, Rdx
		Mov Rax, dwMinBytes
		Mov Rcx, 1024
		IDiv Rcx
		Invoke String, Rax, Rsi, ecDecimal
		Invoke lstrcat, Rsi, TextStrA("KB", 41)
	.EndIf
	Invoke SetWindowText, [App.Main], Addr szBuffer
	Ret
SetCaption EndP

SetControlText Proc FastCall Private Frame ulControl:QWord, lpszText:LPSTR
	Invoke GetWindowItem, IconData.hWnd, ulControl
	Invoke SendMessageA, Rax, WM_SETTEXT, 0, lpszText
	Ret
SetControlText EndP

SetMenuText Proc FastCall Private Frame Uses Rsi hMenu:HMENU, ulMenuID:QWord, ulStringID:QWord, byPosition:QWord
	Local mii:MENUITEMINFO

	Lea Rsi, szBuffer
	Mov Word Ptr [Rsi], 0
	Mov mii.cbSize, SizeOf MENUITEMINFO
	Mov mii.fType, MFT_STRING
	Mov mii.fMask, MIIM_TYPE
	Mov mii.dwTypeData, Rsi
	Invoke LoadAppString, ulStringID, Rsi, 128
	Invoke SetMenuItemInfo, hMenu, ulMenuID, byPosition, Addr mii
	.If byPosition
		Mov Rax, MF_BYPOSITION
	.Else
		Mov Rax, MF_BYCOMMAND
	.EndIf
	Or Rax, MF_ENABLED
	Invoke EnableMenuItem, hMenu, ulMenuID, Rax
	Ret
SetMenuText EndP

SetIPAddressString Proc FastCall Private Frame Uses Rbx Rdi dwAdapterAddress:QWord
	Mov Rbx, dwAdapterAddress
	.If (Rbx <= SQWord Ptr Rbx)
		Mov Rax, dwCurrentIndex
		Cmp Rax, (-1)
		Je L2
		Shl Rax, 3
		Lea Rcx, dwIfTableIndex
		Add Rax, Rcx
		Mov Rbx, [Rax]		;Get adapter data address
	.EndIf
	.If ([Rbx].ADAPTER_DATA.dwAddress == 0)
		Invoke InitInterfaces
		Mov Rax, dwCurrentIndex
		Cmp Rax, (-1)
		Je L2
		Shl Rax, 3
		Lea Rcx, dwIfTableIndex
		Add Rax, Rcx
		Mov Rbx, [Rax]		;Get adapter data address
	.EndIf
	Invoke GetWindowItem, IconData.hWnd, IDC_NETMON_STCIP
	Mov Rdi, Rax
	Invoke IPToStr, [Rbx].ADAPTER_DATA.dwAddress, Addr szBuffer
	Invoke SendMessageA, Rdi, WM_SETTEXT, 0, Addr szBuffer
	Invoke GetWindowItem, IconData.hWnd, IDC_NETMON_STCSUBMASK
	Mov Rdi, Rax
	Invoke IPToStr, [Rbx].ADAPTER_DATA.dwMask, Addr szBuffer
	Invoke SendMessageA, Rdi, WM_SETTEXT, 0, Addr szBuffer
L2:	Ret
SetIPAddressString EndP

SetKBValues Proc FastCall Frame
	.If KBValue == 1024
		Mov dwRS_ONE_KB, 1024
		Mov dwRS_ONE_KB_DIV_10, 102
		Mov dwRS_ONE_MB, 1048576
		Mov dwRS_ONE_MB_DIV_10, 104857
	.Else
		Mov dwRS_ONE_KB, 1000
		Mov dwRS_ONE_KB_DIV_10, 100
		Mov dwRS_ONE_MB, 1000000
		Mov dwRS_ONE_MB_DIV_10, 100000
	.EndIf
	Ret
SetKBValues EndP

SetMonitorSize Proc FastCall Private Frame Uses Rdi Rsi hWnd:HWND
	Local rc:RECT

	.If bSmallSize
		Invoke CopyRect, Addr rc, Addr rcSmall
		Mov Rdi, SW_HIDE
		Mov Rsi, lSmallTop
	.Else
		Invoke CopyRect, Addr rc, Addr rcLarge
		Mov Rdi, SW_SHOWNORMAL
		Mov Rsi, lLargeTop
	.EndIf
	ECInvoke SetWindowPos, hWnd, NULL, rc.left, rc.top, rc.right, rc.bottom, (SWP_NOZORDER OR SWP_FRAMECHANGED)
	Invoke GetWindowItem, hWnd, IDC_NETMON_TABSTRIP1
	Invoke ShowWindow, Rax, Rdi
	Invoke GetWindowItem, hWnd, IDC_NETMON_GROUP1
	Invoke ShowWindow, Rax, Rdi
	Invoke GetWindowItem, hWnd, IDC_NETMON_GROUP2
	Invoke ShowWindow, Rax, Rdi
	Invoke GetWindowItem, hWnd, IDC_NETMON_GROUP3
	Invoke SetWindowPos, Rax, NULL, lLeft, Rsi, 0, 0, (SWP_NOZORDER OR SWP_NOSIZE)
	Invoke wsprintfA, Addr szBuffer, Addr szFormat, bSmallSize
	Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szSmallSize, Addr szBuffer
	Ret
SetMonitorSize EndP

SetPrivileges Proc FastCall Private Frame hProcess:HANDLE, bEnable:QWord
	Local hToken:HANDLE, tp:TOKEN_PRIVILEGES

	Mov Rax, (-1)
	Invoke OpenProcessToken, hProcess, (TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY), Addr hToken
	Invoke LookupPrivilegeValue, NULL, TextStr("SeDebugPrivilege"), Addr tp.Privileges.Luid
	Mov tp.PrivilegeCount, 1
	Xor Rax, Rax
	.If bEnable
		Mov Rax, SE_PRIVILEGE_ENABLED
	.EndIf
	Mov tp.Privileges.Attributes, Eax
	Invoke AdjustTokenPrivileges, hToken, FALSE, Addr tp, SizeOf TOKEN_PRIVILEGES, NULL, NULL
	Mov bEnable, Rax
	Invoke CloseHandle, hToken
	Mov Rax, bEnable
	Ret
SetPrivileges EndP

SetTabItemText Proc FastCall Frame Uses Rsi hWndTabStrip:HWND, lItemIndex:QWord, lStringID:QWord
	Local tcItem:TCITEM

	Lea Rsi, szBuffer
	Mov tcItem.pszText, Rsi
	Mov tcItem._mask, TCIF_TEXT
	Mov tcItem.cchTextMax, 64
	Invoke LoadAppString, lStringID, Rsi, 64
	Invoke SendMessage, hWndTabStrip, TCM_SETITEM, lItemIndex, Addr tcItem
	Ret
SetTabItemText EndP

SetThousand Proc FastCall Private Frame Uses Rbx Rdi Rsi
	Lea Rsi, szBuffer
	Add Rsi, 64
	Mov Rdi, Rsi
	Mov Rbx, Rsi
	Sub Rdi, 2
	Mov Byte Ptr [Rdi], 0
	Dec Rdi
	Invoke lstrlenA, Rsi
	Add Rsi, Rax
	Mov Rcx, 3
L2:	Dec Rsi
	Mov Al, [Rsi]
	Mov [Rdi], Al
	Dec Rdi
	Dec Rcx
	Jnz @F
	Cmp Rsi, Rbx
	Je @F
	Mov Al, [sThousand]
	Mov [Rdi], Al
	Dec Rdi
	Mov Rcx, 3
@@:	Cmp Rsi, Rbx
	Jne L2
	Inc Rdi
	Mov Rax, Rdi
	Ret
SetThousand EndP

ShutDownPC Proc FastCall Private Frame
	Local handle:HANDLE
	Local tp:TOKEN_PRIVILEGES

	Invoke GetCurrentProcess
	Mov Rdx, Rax
	Invoke OpenProcessToken, Rdx, TOKEN_ADJUST_PRIVILEGES OR TOKEN_QUERY, Addr handle
	Invoke LookupPrivilegeValue, NULL, TextStr("SeShutdownPrivilege"), Addr tp.Privileges.Luid
	Mov tp.PrivilegeCount, 1
	Mov tp.Privileges.Attributes, SE_PRIVILEGE_ENABLED
	Invoke AdjustTokenPrivileges, handle, FALSE, Addr tp, SizeOf tp, NULL, NULL
	Invoke SendMessage, App.Main, WM_CLOSE, 0, 0
	Invoke ExitWindowsEx, (EWX_SHUTDOWN OR EWX_POWEROFF OR EWX_FORCE), 0
	Ret
ShutDownPC EndP

StoreAppStrings Proc FastCall Private Frame Uses Rbx Rdi Rsi lpszBuf:LPSTR
	Invoke GlobalAlloc, GPTR, MAX_PATH
	Mov Rbx, Rax
	Mov Rsi, lpszBuf
L2:	Mov Rdi, Rbx
	Xor R10, R10
	Xor R11, R11
	Cmp Byte Ptr [Rsi + R10], 0
	Jne @F
	Invoke GlobalFree, Rbx
	Ret
@@:	Mov Al, Byte Ptr [Rsi + R10]
	Or Al, Al
	Jz @F
	.If Al == '\'
		Inc R10
		Mov Al, Byte Ptr [Rsi + R10]
		.If Al == '0'
			Sub Al, 48
		.ElseIf Al == 't'
			Mov Al, 9
		.ElseIf Al == 'n'
			Mov Al, 10
		.ElseIf Al == 'r'
			Mov Al, 13
		.ElseIf Al == '\'
			Mov Al, '\'
		.ElseIf Al == "'"
			Mov Al, "'"
		.ElseIf Al == '"'
			Mov Al, '"'
		.ElseIf Al == '?'
			Mov Al, '?'
		.ElseIf Al == 'b'
			Mov Al, 8
		.ElseIf Al == 'a'
			Mov Al, 7
		.ElseIf Al == 'f'
			Mov Al, 12
		.ElseIf Al == 'v'
			Mov Al, 11
		.Else
			Dec R10
		.EndIf
	.ElseIf Al == 13 || Al == 10 || Al == 0
		Jmp @F
	.EndIf
	Mov Byte Ptr [Rdi + R11], Al
	Inc R10
	Inc R11
	Jmp @B
@@:	Mov Byte Ptr [Rdi + R11], 0
	Add Rsi, R10
	Invoke FindChar, Rbx, '='
	.If Rax != (-1)
		Inc Rax
		Add Rax, Rbx
	.EndIf
	Invoke SendMessage, hWndLBStr, LB_ADDSTRING, 0, Rax
	.While Byte Ptr [Rsi] < 32
		.If Byte Ptr [Rsi]
			.If Byte Ptr [Rsi] < 32
				Inc Rsi
			.EndIf
		.Else
			.Break
		.EndIf
	.EndW
	Jmp L2
StoreAppStrings EndP

UpdateBytes Proc FastCall Private Frame Uses Rbx Rdi Rsi bForce:QWord
	Mov Rax, dwCurrentIndex
	Cmp Rax, (-1)
	Je L4
	Shl Rax, 3
	Lea Rcx, dwIfTableIndex
	Add Rax, Rcx
	Mov Rbx, [Rax]
	Lea Rsi, szBuffer
	Add Rsi, 64
	Cmp bForce, FALSE
	Jne @F
	Mov Rax, MibIfRow2.InOctets
	Cmp Rax, [Rbx].ADAPTER_DATA.dwLastBytesIn
	Je L2
@@:	Invoke StringA, MibIfRow2.InOctets, Rsi, ecDecimal
	Invoke SetThousand
	Invoke SetControlText, IDC_NETMON_STCRECEIVED, Rax
L2:	Cmp bForce, FALSE
	Jne @F
	Mov Rax, MibIfRow2.OutOctets
	Cmp Rax, [Rbx].ADAPTER_DATA.dwLastBytesOut
	Je L4
@@:	Invoke StringA, MibIfRow2.OutOctets, Rsi, ecDecimal
	Invoke SetThousand
	Invoke SetControlText, IDC_NETMON_STCSENT, Rax
L4:	Ret
UpdateBytes EndP

UpdateLights Proc FastCall Frame Uses Rbx Rdi Rsi bUpdateSpeed:QWord, bForce:QWord
	.If dwNetState != STATUS_DISCONN
		Mov Rax, dwCurrentIndex
		Cmp Rax, (-1)
		Jne @F
		Ret
@@:		Shl Rax, 3
		Lea Rcx, dwIfTableIndex
		Add Rax, Rcx
		Mov Rbx, [Rax]
		Mov Rdi, MibIfRow2.InOctets
		Mov Rsi, MibIfRow2.OutOctets
		.If Rdi != [Rbx].ADAPTER_DATA.dwLastBytesIn && Rsi != [Rbx].ADAPTER_DATA.dwLastBytesOut
			Sub Rdi, [Rbx].ADAPTER_DATA.dwLastBytesIn
			Sub Rsi, [Rbx].ADAPTER_DATA.dwLastBytesOut
			.If dwNetState != (STATUS_RECEIVE OR STATUS_SEND) && (MibIfRow2.InOctets || MibIfRow2.OutOctets)
				Mov dwNetState, (STATUS_RECEIVE Or STATUS_SEND)
				Mov bUpdateSpeed, TRUE
				Mov Rax, hIconBoth
@@:				Cmp Rax, IconData.hIcon
				Je L4
				Invoke SetIcons, Rax
			.EndIf
		.ElseIf Rdi != [Rbx].ADAPTER_DATA.dwLastBytesIn
			Sub Rdi, [Rbx].ADAPTER_DATA.dwLastBytesIn
			Xor Rsi, Rsi
			.If dwNetState != STATUS_RECEIVE
				Mov dwNetState, STATUS_RECEIVE
				Mov bUpdateSpeed, TRUE
				Mov Rax, hIconReceive
				Jmp @B
			.EndIf
		.ElseIf Rsi != [Rbx].ADAPTER_DATA.dwLastBytesOut
			Xor Rdi, Rdi
			Sub Rsi, [Rbx].ADAPTER_DATA.dwLastBytesOut
			.If dwNetState != STATUS_SEND
				Mov dwNetState, STATUS_SEND
				Mov bUpdateSpeed, TRUE
				Mov Rax, hIconSend
				Jmp @B
			.EndIf
		.Else
			Xor Rdi, Rdi
			Xor Rsi, Rsi
			.If dwNetState != STATUS_NONE
				Mov dwNetState, STATUS_NONE
				Mov bUpdateSpeed, TRUE
				Mov Rax, hIconNone
				Jmp @B
			.EndIf
		.EndIf
L4:		Invoke UpdateBytes, FALSE
		.If bUpdateSpeed
			Invoke UpdateSpeed, Rdi, IDC_NETMON_STCSPEEDIN, Addr [Rbx].ADAPTER_DATA.dwLastSpeedIn, bForce
			Invoke UpdateSpeed, Rsi, IDC_NETMON_STCSPEEDOUT, Addr [Rbx].ADAPTER_DATA.dwLastSpeedOut, bForce
		.EndIf
	.EndIf
@@:	Ret
UpdateLights EndP

UpdateSpeed Proc FastCall Private Frame Uses Rbx Rdi Rsi dwBytesSecond:QWord, ulControl1:QWord, lpdwLastSpeed:QWord, bForce:QWord
	.If SQWord Ptr SpeedScale > 0
		Mov Rax, dwBytesSecond
		Mov Rcx, 1000000
		Mul Rcx
		Xor Rdx, Rdx
		Div SpeedScale
		Mov dwBytesSecond, Rax
	.EndIf
	Invoke ConvertToScale, dwBytesSecond
	Mov dwBytesSecond, Rax
	Mov Rdx, lpdwLastSpeed
	Cmp bForce, FALSE
	Jne @F
	Cmp Rax, QWord Ptr [Rdx]
	Jne @F
	Ret
@@:	Mov [Rdx], Rax
	Mov Rdi, dwRS_ONE_KB
	Mov Rsi, dwRS_ONE_KB_DIV_10
	Mov Rbx, IDS_KBYTES
	Cmp bBits, FALSE
	Je @F
	Mov Rbx, IDS_KBITS
@@:	Cmp Rax, dwRS_ONE_MB
	Jl L2
	Mov Rbx, IDS_MBYTES
	Cmp bBits, FALSE
	Je @F
	Mov Rbx, IDS_MBITS
@@:	Mov Rdi, dwRS_ONE_MB
	Mov Rsi, dwRS_ONE_MB_DIV_10
L2:	Invoke GetSpeedString, Rax, Rdi, Rsi
	Lea Rsi, szBuffer
	Invoke lstrlenA, Addr szBuffer
	Add Rsi, Rax
	Mov Byte Ptr [Rsi], VK_SPACE
	Inc Rsi
	Invoke LoadAppString, Rbx, Rsi, 20
	Invoke SetControlText, ulControl1, Addr szBuffer
	Mov Rdi, lMeterDownIndex
	Cmp ulControl1, IDC_NETMON_STCSPEEDIN
	Je @F
	Mov Rdi, lMeterUpIndex
@@:	Invoke SetMeterValue, Rdi, dwBytesSecond
	Ret
UpdateSpeed EndP
